<?php

namespace HCM\FPA\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use HCM\FPA\Services\RelatCustomSituFuncService;
use HCM\Util\Util;

class RelatCustomSituFuncController extends Crud {

    public function __construct (Manager $dataSourceManager, RelatCustomSituFuncService $relatCustomSituFuncService){
        $this->relatCustomSituFuncService = $relatCustomSituFuncService;
        parent::__construct($dataSourceManager);
    }

    public function getRelatCustomSituFunc(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $filters = Util::removerCaracterePorcentagemString($request->getFilterCriteria()->getConditions());
            
            $result = $this->relatCustomSituFuncService->getRelatCustomSituFunc($filters);
            
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getRelatCustomSituFunc', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }
} 