<?php


namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\MsgCalculo;
use HCM\FPA\Entity\FpaincideventoEntity;
use HCM\Util\Util;
use HCM\Util\FPA;
use HCM\Util\DateUtil;
use HCM\Util\TkEntity;
use HCM\FPA\Entity\FpaformrescisaoEntity;
use HCM\FPA\Entity\FpaeventohEntity;
use HCM\FPA\Entity\FpaeventomEntity;
use HCM\FPA\Entity\FpatipoassoceveEntity;
use HCM\Util\Valor;
use Zeedhi\Framework\ORM\DateTime;
use HCM\FPA\Calculos\Geral\MemoriaCalculo;
use HCM\FPA\Calculos\Geral\Inicializa;
use HCM\FPA\ObrigacaoLegal\Dirf\Registros\RegistroDIRF;
use Teknisa\Model\Gestaopessoas\Entities\FpaItecalcfolha;

class FpaitecalcfolhaEntity extends TkEntity
{
    
    const VALOR = 'VAL';
    const REFERENCIA = 'REF';
    const PARCELA = 'PRC';
    const NENHUMA = 'N';
    const MAIS = '+';
    const MENOS = '-';
    const EVENTO_COMISSAO = '140';
    const EVENTO_SALARIO_MES = '10';
    const EVENTO_SALARIO_HORA = '20';
    const IDEVENDEMONCALC_NAO = 'N';
    const IDEVENDEMONCALC_SIM = 'S';
    const IDREFEVALORCALC_NORMAL = 'NORMAL';
    const IDREFEVALORCALC_REFERENCIA = 'REFERENCIA';
    const IDREFEVALORCALC_VALOR = 'VALOR';
    const IDREFEVALORCALC_REFERENCIA_VALOR = 'REFERENCIA_VALOR';
    const IDREFEVALORCALC_REFERENCIA_RECALCULO = 'REFERENCIA_RECALCULO';
    const IDREFEVALORCALC_VALOR_RECALCULO = 'VALOR_RECALCULO';
    const IDREFEVALORCALC_REFERENCIA_VALOR_RECALCULO = 'REFERENCIA_VALOR_RECALCULO';

    private $_totalReferencias;
    private $evento;
    private $itensCalcFolha;
    private $nrCalculofolha;
    private $nrVinculom;
    
    public function __construct($entityManager, $hcmParameters, $nrCalculoFolha = null, $dtMesCompetencia = null) {
        parent::__construct(null, $entityManager);
        $this->hcmParameters = $hcmParameters;
        $this->nrorg = $hcmParameters->getNrorgTrabalho();
        $this->nrorgPadrao = $hcmParameters->getNrorgPadrao();
        $this->mesCompetencia = substr($dtMesCompetencia, 0, 10) ? substr($dtMesCompetencia, 0, 10) : $hcmParameters->getDtCompetencia();
        $this->fpaItecalcFolha = Repositories::FPA_ITECALCFOLHA;
        $this->incideventoEntity = new FpaincideventoEntity($entityManager, $hcmParameters);
        $this->verificaVinculo = true;
        
        if($nrCalculoFolha){
            $this->setNrcalculofolha($nrCalculoFolha);
        }
    }
    
    public function setMesCompetencia($mesCompetencia){
        $this->mesCompetencia = $mesCompetencia;
    }
       
    public function retornaValor($indice){
        if($indice == -1){
            return 0;
        }
        return strval($this->getItem($indice)->getVreventofolha());
    }

    public function retornaContador($indice){
        return $this->getItem($indice)->getQtocorproxperi();
    }

    public function retornaEvento($indice){
        return $this->getItem($indice)->getNreventom();
    }

    public function retornaReferencia($indice){
        return $this->getItem($indice)->getVrreffolha();
    }

    public function retornaDtocorrencia($indice){
        return $this->getItem($indice)->getDtocorrencia();
    }
    
    public function retornaNrvinculom($indice){
        return $this->getItem($indice)->getNrvinculom();
    }


    public function getTotalReferencias(){
        return $this->_totalReferencias;
    }

    public function atribuiCalculoDemonstrativo($posicao, $id_demo){
        if ($posicao !== -1) {
            $item = $this->getItem($posicao);
            $item->setIdevendemoncalc($id_demo);
        }
    }

    private function _verificaRemoveItem($valor, $idGeraValorZero, $item){
        if (($valor === 0.0) && ($idGeraValorZero === FpaeventohEntity::IDGERAVRZERO_NAO)) {
            if ($item->getIdrefevalorcalc() !== FpaitecalcfolhaEntity::IDREFEVALORCALC_VALOR
                && $item->getIdrefevalorcalc() !== FpaitecalcfolhaEntity::IDREFEVALORCALC_REFERENCIA_VALOR
                && $item->getIdrefevalorcalc() !== FpaitecalcfolhaEntity::IDREFEVALORCALC_REFERENCIA_VALOR_RECALCULO
                && $item->getIdrefevalorcalc() !== FpaitecalcfolhaEntity::IDREFEVALORCALC_VALOR_RECALCULO
            ) {
                $this->removeItem($item);
                return true;
            }
         }

         return false;
    }

    public function geraEvento(
        $evento, $mes_ocorrencia = null, $valor, $referencia, $contador, $tipoLancamento = null, $nrgozoFerias = null
    ){
        $nrevento = $evento->getNreventom();
       
        $posicao = $this->procuraEvento($evento, $mes_ocorrencia);
        $truncaDigito3 = false;
       
        $difFolhaComp = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->nrorg, $this->nrorgPadrao, $this->mesCompetencia, FpaValorreferenciamEntity::ID_TRUNCA_DIGITO_3);                
        
        if($difFolhaComp == 1){
            $truncaDigito3 = true;
        }
         
        if ($posicao !== -1) {
            $item = $this->getItem($posicao);
            
            $removeItem = $this->_verificaRemoveItem($valor, $evento->historico->getIdgeravrzero(), $item);
            if ($removeItem === true) {
                return;
            }
            
            if ($item->getIdrefevalorcalc() !== self::IDREFEVALORCALC_VALOR
                && $item->getIdrefevalorcalc() !== self::IDREFEVALORCALC_REFERENCIA_VALOR
                && $item->getIdrefevalorcalc() !== self::IDREFEVALORCALC_VALOR_RECALCULO
                && $item->getIdrefevalorcalc() !== self::IDREFEVALORCALC_REFERENCIA_VALOR_RECALCULO
            ) {
                
                $valor = Valor::arredonda(
                    $valor, $evento->historico->getIdtipoarredonda(), $evento->historico->getNrdigarredonda(),
                    $evento->historico->getVrlimitearred(), $truncaDigito3
                );
                $item->setVreventofolha($valor);
            }
            
            if($item->getVrvelho() > 0 && $item->getVrvelho() != $valor && $this->_nrTipoCalculo == FpatipocalculoEntity::CALC_PROVISAO_CONTABIL){
                $item->setVreventofolha($item->getVrvelho());
            }
            
            if ($valor < $evento->historico->getVrpisoevento()) {
                $item->setVreventofolha($evento->historico->getVrpisoevento());
            } elseif ($valor >$evento->historico->getVrtetoevento()) {
                $item->setVreventofolha($evento->historico->getVrtetoevento());
            }
            
            if ($item->getIdrefevalorcalc() !== self::IDREFEVALORCALC_REFERENCIA
                && $item->getIdrefevalorcalc() !== self::IDREFEVALORCALC_REFERENCIA_VALOR
                && $item->getIdrefevalorcalc() !== self::IDREFEVALORCALC_REFERENCIA_RECALCULO
                && $item->getIdrefevalorcalc() !== self::IDREFEVALORCALC_REFERENCIA_VALOR_RECALCULO
            ) {
                if ($referencia !== null) {
                    $item->setVrreffolha($referencia);
                }
            }
            if ($contador !== null) {
                $item->setQtocorproxperi($contador);
            }
        } else {
            if (($valor === 0.0)
                && ($evento->historico->getIdgeravrzero() === FpaeventohEntity::IDGERAVRZERO_NAO)
            ) {
                return;
            }
            
            if ($mes_ocorrencia === null) {
                $tipoData = $evento->historico->getIddtocorrencia();
                switch ($tipoData) {
                case FpaeventohEntity::IDDTOCORRENCIA_COMPETENCIA:
                    $mes_ocorrencia = $this->mesCompetencia;
                    break;
                case FpaeventohEntity::IDDTOCORRENCIA_PAGAMENTO:
                    $mes_ocorrencia = $this->hcmParameters->getDtPagamento();
                    break;
                }
            }
            
            $valor = Valor::arredonda(
                $valor, $evento->historico->getIdtipoarredonda(), $evento->historico->getNrdigarredonda(),
                $evento->historico->getVrlimitearred(), $truncaDigito3
            );
            if ($valor<$evento->historico->getVrpisoevento()) {
                $valor=$evento->historico->getVrpisoevento();
            } elseif ($valor>$evento->historico->getVrtetoevento()) {
                $valor=$evento->historico->getVrtetoevento();
            }  
            
            
            $tipoLancamento = $tipoLancamento ? $tipoLancamento : self::IDREFEVALORCALC_NORMAL;
            $mes_ocorrencia = DateUtil::getDataDeString(substr($mes_ocorrencia, 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
            $item = new $this->fpaItecalcFolha;
            $item->setVreventofolha($valor);
            $item->setVrreffolha($referencia);
            $item->setDtocorrencia($mes_ocorrencia);
            $item->setQtocorproxperi($contador);
            $item->setNreventom($nrevento);
            $item->setNrcalculofolha($this->nrCalculofolha);
            $item->setIdevendemoncalc($evento->historico->getIdeventodemonst());
            $item->setNrvinculom($this->nrVinculom);
            $item->setIdrefevalorcalc($tipoLancamento);
            $item->setNrgozoferias($nrgozoFerias);
            $item->setNrorg($this->nrorg);
            $item->setDtultatu(new DateTime());
            $item->setDtinclusao(new DateTime());
            $item->setCdoperultatu($this->hcmParameters->getCdoperador());
            $item->setCdoperinclusao($this->hcmParameters->getCdoperador());
            $item->setNritemcalcfolha(\HCM\Util\NovoCodigo::geraCodigo($this->nrorg, 'FPA_ITECALCFOLHA', 1, 12, true));
            
            $this->addItem($item);
        }
    }
    
    public function retornaValorEvento(
        $evento, $mes_ocorrencia = null, $valor, $referencia, $contador, $tipoLancamento = null, $nrgozoFerias = null, $base = 0, $jornada_diaria = 0
    ){
        $nrevento = $evento->getNreventom();
       
        $posicao = $this->procuraEvento($evento, $mes_ocorrencia);
        $truncaDigito3 = false;
        $percentual = $evento->historico->getVrpercentualevento();
        
        $listaHorasExtras = Inicializa::getListaEventoHoraExtra();
        $extra = array_search($nrevento, $listaHorasExtras);
        
        if($extra){$percentual += 100;}
        
        $difFolhaComp = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->nrorg, $this->nrorgPadrao, $this->mesCompetencia, FpaValorreferenciamEntity::ID_TRUNCA_DIGITO_3);                
        
        if($difFolhaComp == 1){
            $truncaDigito3 = true;
        }
        
        if($valor > 0){
       
            $valor = Valor::arredonda(
                $valor, $evento->historico->getIdtipoarredonda(), $evento->historico->getNrdigarredonda(),
                $evento->historico->getVrlimitearred(), $truncaDigito3
            );
            
            if ($valor < $evento->historico->getVrpisoevento()) {
                $valor = $evento->historico->getVrpisoevento();
            } elseif ($valor >$evento->historico->getVrtetoevento()) {
                $valor = $evento->historico->getVrtetoevento();
            }
            
        }else{
            $tipo_referencia = $evento->historico->getIdunidrefereven();
            $qtd_dias = 0;
            
            switch ($tipo_referencia) {
                case FpaeventohEntity::IDUNIDREFEREVEN_PERCENTUAL:
                    if($referencia != 0){
                        $valor = ($base * $referencia)/100;
                    }
                    break;
                case FpaeventohEntity::IDUNIDREFEREVEN_DIA :
                case FpaeventohEntity::IDUNIDREFEREVEN_HORA :
                case FpaEventohEntity::IDUNIDREFEREVEN_HORA_MINUTO:
                    
                    $valor_hora = $base / ($jornada_diaria * 30);
					
                    $valor_hora = ($valor_hora * $percentual)/100;
                    
                    $ref_hora = FpaeventomEntity::compatibilizaReferenciaHoras(
                        $referencia, $tipo_referencia, $jornada_diaria
                    );
                    
                    $valor = $valor_hora * $ref_hora;
                    
                    if ($referencia === $ref_hora) {
                        $qtd_dias += ($referencia / $jornada_diaria);
                    } else {
                        if ($tipo_referencia === FpaeventohEntity::IDUNIDREFEREVEN_DIA) {
                            $qtd_dias += $referencia;
                        } else {
                            $qtd_dias += ($ref_hora / $jornada_diaria);
                        }
                    }
                    break;
                case FpaeventohEntity::IDUNIDREFEREVEN_12_AVOS:
                    $valor = ($base * $referencia)/12;
                    $valor = ($valor * $percentual)/100;
                    break;
                default:
                    break;
                    
                    $valor = Valor::arredonda(
                        $valor, $evento->historico->getIdtipoarredonda(), $evento->historico->getNrdigarredonda(),
                        $evento->historico->getVrlimitearred(), $truncaDigito3
                    );                    
            }
        }
        
        return $valor;
    }

    public function subtraiValor(
        $evento_origem, $evento_destino, $dt_ocorrencia, $aceitanegativo=true
    ) {
        
        $valor_origem = $this->retornaValorPorEvento($evento_origem, $dt_ocorrencia);
        $valor_destino = $this->retornaValorPorEvento($evento_destino, $dt_ocorrencia);
        
        $diferenca = $valor_origem - $valor_destino;
        
        if ($aceitanegativo==false && $diferenca<0){
            $diferenca=0;
        }
        $this->geraEvento($evento_destino, $dt_ocorrencia, $diferenca, null, null);
    }

    public function retornaValorPorEvento($evento, $dt_ocorrencia = null) {
        $posicao = $this->procuraEvento($evento, $dt_ocorrencia);
        if ($posicao !== -1) {
            $valor = $this->retornaValor($posicao);
        } else {
            $valor = 0;
        }
        return $valor;
    }

    public function retornaDtOcorrenciaPorEvento($evento, $dt_ocorrencia = null) {
        $posicao = $this->procuraEvento($evento, $dt_ocorrencia);
        if ($posicao !== -1) {
            $dtocorrencia = $this->retornaDtocorrencia($posicao);
        } else {
            $dtocorrencia = null;
        }
        return $dtocorrencia;
    }
    
    public function retornaContadorPorEvento($evento, $dt_ocorrencia = null) {
        $posicao = $this->procuraEvento($evento, $dt_ocorrencia);
        if ($posicao !== -1) {
            $contador = $this->retornaContador($posicao);
        } else {
            $contador = 1;
        }
        return $contador;
    }

    public function retornaReferenciaPorEvento($evento, $dt_ocorrencia = null) {
        $posicao = $this->procuraEvento($evento, $dt_ocorrencia);
        if ($posicao !== -1) {
            $referencia = $this->retornaReferencia($posicao);
        } else {
            $referencia = 0;
        }
        return $referencia;
    }

    public function procuraEvento($evento, $mes_ocorrencia = null){
        $itens = $this->getItems();
        $numero_mes = null;
        $numero_ano = null;
        if($mes_ocorrencia){
            $mes = DateUtil::getDataDeString(substr($mes_ocorrencia,0,10), DateUtil::FORMATO_BRASILEIRO, true);
            $numero_mes = $mes->format('m');
            $numero_ano = $mes->format('Y');
        }
        foreach ($itens as $indice => $item) {
            $nrevento_item = $item->getNreventom();
            $nrevento_evento = $evento->getNreventom();
            $dt_item = DateUtil::getDataDeString(substr($item->getDtocorrencia(), 0, 10), DateUtil::FORMATO_BRASILEIRO, true);
        
            if ($mes_ocorrencia !== null) {
                if (((int)$nrevento_item === (int)$nrevento_evento)
                    && ($dt_item->format('m') == $numero_mes)
                    && ($dt_item->format('Y') == $numero_ano)
                ) {
                    unset($mes);
                    return $indice;
                }
            } else {
                if ((int)$nrevento_item === (int)$nrevento_evento) {
                    unset($mes);
                    return $indice;
                }
            }
        }
        return -1;
    }

    public function procuraEventoPorNreventoDtocorrencia($nreventom, $dtocorrencia = null){
        $itens = $this->getItems();
        foreach ($itens as $indice => $item) {
            $nrevento_item = $item->getNreventom();
            if (((int)$nrevento_item === (int)$nreventom)) {
                if (is_null($dtocorrencia)) {
                    return $indice;
                }
                else {
                    $dtocorrencia_item = DateUtil::getDataDeString($item->getDtocorrencia());
                    $dtocorrencia_evento = DateUtil::getDataDeString($dtocorrencia);
                    if ($dtocorrencia_item->format('d/m/Y') == $dtocorrencia_evento->format('d/m/Y')) {
                        unset($dtocorrencia_item);
                        unset($dtocorrencia_evento);
                        return $indice;
                    }
                }
            }
        }
        return -1;
    }

    public function verificaFechamento($assoc_eventos, $eventom, $nrOrg){
        $evento_aux = $assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_FECHADO, $eventom, $nrOrg);
        $itens = $this->retornaItens($evento_aux);
        if (empty($itens) === false) {
            return true;
        } else{
                return false;
              }
    }
    
    public function verificaEventosRecalculo(){
        
        $itens = $this->getItems();
        
        if($itens){
            foreach($itens as $item){
                if(strstr($item->getIdrefevalorcalc(), '_RECALCULO')){
                    return true;
                }
            }
        }
        
        return false;
    }
    
    public function verificaLiquido($assoc_eventos, $eventom, $nrOrg){
        $evento_aux = $assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_LIQUIDO, $eventom, $nrOrg);
        $itens = $this->retornaItens($evento_aux);
        
        if (empty($itens) === false) {
            return true;
        } else { 
            $evento_aux = $assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_LIQUIDO_RESCISAO, $eventom, $nrOrg);
            $itens = $this->retornaItens($evento_aux);
            if (empty($itens) === false) {
                return true;
            } else{
                return false;
            }
        }
    }

    public function verificaLiquidoParcial($assoc_eventos, $eventom, $nrOrg){
        $evento_aux = $assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_LIQUIDO_PARCIAL, $eventom, $nrOrg
        );
        $itens = $this->retornaItens($evento_aux);
        if (empty($itens) === false) {
            return true;
        } else {
            return false;
        }
    }

    public function retornaItens($evento){
        $posicoes = array();
        $itens = $this->getItems();
        foreach ($itens as $indice => $item) {
            $item->getNreventom();
            $evento->getNreventom();
            if ($item->getNreventom() === $evento->getNreventom()) {
                $posicoes[] = $indice;
            }
        }
        return $posicoes;
    }

    public function retornaItensPorNrvinculom($nr_org, $nr_vinculo){

        $this->resetItems();
        $contador = 0;
        $this->nrVinculom = $nrvinculo;
        
        $resultado = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->findBy(array('nrorg' => $nr_org,
        'nrvinculom' => $nr_vinculo));
        
        if (empty($resultado) === false) {
            $this->itensCalcFolha = $resultado;
            foreach ($resultado as $entity_obj) {
                $this->addItem($entity_obj);
                $contador++;
            }
        }
        return $contador;
    }
    
    public function retornaItemPorNrGozo($nr_org, $nr_vinculo, $nrGozo, $nreventom){

        $resultado = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->findOneBy(array('nrorg' => $nr_org,
        'nrvinculom' => $nr_vinculo, 'nrgozoferias' => $nrGozo, 'nreventom' => $nreventom));
        
        return $resultado;
    }

    public function retornaItensPorVinculo($nrorg, $nrvinculo, $nrcalculo){
        if ($nrcalculo === null) {
            MsgCalculo::getInstance()->adicionaMensagem('Numero de calculo nulo.',MsgCalculo::ERRO,true);
        }
        $this->resetItems();
        $contador = 0;
        
        $this->nrVinculom = $nrvinculo;
        $this->nrCalculofolha = $nrcalculo;
        
        $resultado = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->findBy(array('nrorg' => $nrorg,
        'nrvinculom' => $nrvinculo,'nrcalculofolha' => $nrcalculo));

        if (empty($resultado) === false) {
            foreach ($resultado as $entity_obj) {
                $this->addItem($entity_obj);
                $contador++;
            }
        }
        
        return $contador;
    }

    public function retornaItensPorVinculoAndEvento($nr_org, $nr_vinculo, $nr_calculo, $nr_evento){

        if ($nr_calculo === null) {
            MsgCalculo::getInstance()->adicionaMensagem('Numero de calculo nulo.',MsgCalculo::ERRO,true);
        }
        
        $this->nrVinculom = $nr_vinculo;
        $this->nrCalculofolha = $nr_calculo;
        $this->nrEvento = $nr_evento;

        $this->resetItems();
        $contador = 0;
        
        $resultado = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->findBy(array('nrorg' => $nr_org,
        'nrvinculom' => $nr_vinculo,'nrcalculofolha' => $nr_calculo, 'nreventom' => $nr_evento));
        
        if (empty($resultado) === false) {
            foreach ($resultado as $entity_obj) {
                $this->addItem($entity_obj);
                $contador++;
            }
        }
        return $contador;
    }

    public function retornaItensPorVinculoDirf($nrorg, $nrpessoa, $dtmescompetenc, $nrtpmodalidcal, $nrregimeapur, $dsOrdem, $dsInicio, $dsFim, $nmitem){
        $this->resetItems();
        $contador = 0;
        
        $resultado = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->retornaItensDIRF($nrorg, $nrpessoa, $dtmescompetenc, $nrtpmodalidcal, $nrregimeapur, $dsOrdem, $dsInicio, $dsFim, $nmitem);

        /*if (empty($resultado) === false) {
            foreach ($resultado as $entity_obj) {
                $this->addItem($entity_obj);
                $contador++;
            }
        }
        
        return $contador;*/

        return $resultado;
    }

    public function retornaTotais($eventom){
        $totais = array(
            FpaeventomEntity::IDTIPOEVENTO_PROVENTO => 0, FpaeventomEntity::IDTIPOEVENTO_DESCONTO => 0,
            FpaeventomEntity::IDTIPOEVENTO_ENCARGO => 0, FpaeventomEntity::IDTIPOEVENTO_TOTAL => 0,
        );
        foreach ($this->getItems() as $item) {
            $evento = $eventom->retornaEvento($item->getNreventom());
            if (is_object($evento) === true) {
                if ($item->getIdevendemoncalc() === self::IDEVENDEMONCALC_NAO) {
                    $totais[$evento->getIdtipoevento()] += (float)$item->getVreventofolha();
                }
            } else {
                MsgCalculo::getInstance()->adicionaMensagem('Calculo de Totais: Evento '.$item->getNreventom().' não encontrado para a Organização.');
            }
        }
        return $totais;
    }

    public function debugaArrayEventos($eventom){
        $eventos = array(
            FpaeventomEntity::IDTIPOEVENTO_PROVENTO => 0, FpaeventomEntity::IDTIPOEVENTO_DESCONTO => 0,
            FpaeventomEntity::IDTIPOEVENTO_ENCARGO => 0, FpaeventomEntity::IDTIPOEVENTO_TOTAL => 0,
        );
        foreach ($this->getItems() as $item) {
            $evento = $eventom->retornaEvento($item->getNreventom());
            if (is_object($evento) === true) {
                $eventos[$evento->getIdtipoevento()] += (float)$item->getVreventofolha();
            } else {
                MsgCalculo::getInstance()->adicionaMensagem('DebugCalculo de Totais: Evento '.$item->getNreventom().' não encontrado para a Organização.');
            }
        }

        return $eventos;
    }

    public function calculaIncidencias($tipo_incidencia, $data_competencia, $evento,
                                       $referenciaOcorrencia = false)
    {
        $base = 0.0;
        $this->_totalReferencias = 0;
        $bases = array();
        
        foreach ($this->getItems() as $item) {
            $this->_totalReferencias = 0;

            $evento = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->findOneBy(array('nrorg' => array($this->nrorg,$this->nrorgPadrao),'nreventom' => $item->getNreventom()));
            if (is_object($evento)) {
                $lista_id_aux_incide_evento = $this->incideventoEntity->incide(
                    $tipo_incidencia, $evento->getNreventom(), $data_competencia
                );
                if($lista_id_aux_incide_evento){
                    foreach($lista_id_aux_incide_evento as $nrOrg => $aux_incide_evento){
                        if ($aux_incide_evento === self::MAIS) {
                            $base += $item->getVreventofolha();
                            $this->_totalReferencias += $item->getVrreffolha();
                        } elseif ($aux_incide_evento === self::MENOS) {
                            $base -= $item->getVreventofolha();
                            $this->_totalReferencias -= $item->getVrreffolha();
                        }
                        
                        if ($referenciaOcorrencia && $aux_incide_evento === self::MAIS) {
                            $dtocorrencia = DateUtil::getDataDeString(substr($item->getDtocorrencia(), 0, 10),DateUtil::FORMATO_BRASILEIRO, true);
                            $bases[$dtocorrencia->getTimestamp()] = isset($bases[$dtocorrencia->getTimestamp()]) ?
                                $bases[$dtocorrencia->getTimestamp()] + $item->getVreventofolha() : $item->getVreventofolha();
                        }elseif ($referenciaOcorrencia && $aux_incide_evento === self::MENOS) {
                            $dtocorrencia = DateUtil::getDataDeString(substr($item->getDtocorrencia(), 0, 10),DateUtil::FORMATO_BRASILEIRO, true);
                            $bases[$dtocorrencia->getTimestamp()] = isset($bases[$dtocorrencia->getTimestamp()]) ?
                                $bases[$dtocorrencia->getTimestamp()] - $item->getVreventofolha() : $item->getVreventofolha();
                        }
                        MemoriaCalculo::getInstance()->escreveEventoIncidencia($evento,$item->getVreventofolha(),$this->_totalReferencias,$aux_incide_evento);
                    }
                }    
            } else {
                MsgCalculo::getInstance()->adicionaMensagem('Calculo de Incidencias: Evento '.$item->getNreventom().' não encontrado para a Organização');
            }
            
        }
        MemoriaCalculo::getInstance()->escreveIncidencia($tipo_incidencia,$base);
        return ($referenciaOcorrencia) ? $bases : $base;
    }
    
    public function calculaIncidenciasComItensAnterior($item_de_calculo, $itemsAnterior, $incidencia, $mes_competencia, $eventom, $referenciaOcorrencia = false){	 
        $base = 0.0;	 
        $this->_totalReferencias = 0;	 
        $bases = array();	 
        	 
        $items = $this->getItems();	 
        $itemsAnt = $itemsAnterior->getItems();	 
        $items = array_merge($items, $itemsAnt);	 
        
        foreach ($items as $item) {	 
            $this->_totalReferencias = 0;
            $evento = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->findOneBy(array('nrorg' => array($this->nrorg,$this->nrorgPadrao),'nreventom' => $item->getNreventom()));	 
            if (is_object($evento)) {	 
                $lista_id_aux_incide_evento = $this->incideventoEntity->incide(	 
                    $incidencia, $evento->getNreventom(), $data_competencia	 
                );	 
                if($lista_id_aux_incide_evento){	 
                    foreach($lista_id_aux_incide_evento as $nrOrg => $aux_incide_evento){	 
                        if ($aux_incide_evento === self::MAIS) {	 
                            $base += $item->getVreventofolha();	 
                            $this->_totalReferencias += $item->getVrreffolha();	 
                        } elseif ($aux_incide_evento === self::MENOS) {	 
                            $base -= $item->getVreventofolha();	 
                            $this->_totalReferencias -= $item->getVrreffolha();	 
                        }	 
                        	 
                        if ($referenciaOcorrencia && $aux_incide_evento === self::MAIS) {	 
                            $dtocorrencia = DateUtil::getDataDeString(substr($item->getDtocorrencia(), 0, 10),DateUtil::FORMATO_BRASILEIRO, true);	 
                            $bases[$dtocorrencia->getTimestamp()] = isset($bases[$dtocorrencia->getTimestamp()]) ?	 
                                $bases[$dtocorrencia->getTimestamp()] + $item->getVreventofolha() : $item->getVreventofolha();	 
                        }elseif ($referenciaOcorrencia && $aux_incide_evento === self::MENOS) {	 
                            $dtocorrencia = DateUtil::getDataDeString(substr($item->getDtocorrencia(), 0, 10),DateUtil::FORMATO_BRASILEIRO, true);	 
                            $bases[$dtocorrencia->getTimestamp()] = isset($bases[$dtocorrencia->getTimestamp()]) ? $bases[$dtocorrencia->getTimestamp()] - $item->getVreventofolha() : $item->getVreventofolha();	 
                        }	 
                    }	 
                }    	 
            } else {	 
                MsgCalculo::getInstance()->adicionaMensagem('Calculo de Incidencias: Evento '.$item->getNreventom().' não encontrado para a Organização');	 
            }	 
            	 
        }	 
        
        return ($referenciaOcorrencia) ? $bases : $base;	 
    }
    
    public function calculaReferenciaIncidencias($tipo_incidencia, $data_competencia){

        $ref = 0;
        foreach ($this->getItems() as $item) {

            $evento = $eventom->retornaEvento($item->getNreventom());

            $aux_incide_evento = $this->incideventoEntity->incide(
                $tipo_incidencia, $evento->getNreventom(), $data_competencia
            );
            if ($aux_incide_evento === true) {
                $ref += $item->getVrreffolha();
            }
        }
        return $ref;
    }

    public function apagaItemCalculo(){
        $remove = false;
        foreach ($this->getItems() as $item) {
            $this->removeItem($item);
            $remove = true;
        }
        return $remove;
    }

    public function executaRetrocesso($eventom){
        foreach ($this->getItems() as $item) {
            $evento = $eventom->retornaEvento($item->getNreventom());
            if ($evento->historico->getIdretrocedevent() === FpaeventohEntity::IDRETROCEDEVENT_SEMPRE) {
                if ($item->getIdrefevalorcalc() !== self::IDREFEVALORCALC_NORMAL) {
                    switch ($item->getIdrefevalorcalc()){
                    case self::IDREFEVALORCALC_REFERENCIA:
                        $item->setVreventofolha(0); break;
                    case self::IDREFEVALORCALC_VALOR:
                        $item->setVrreffolha(0); break;
                    }
                } else {
                    if ($evento->historico->getIdtipoocorreven() === FpaeventohEntity::IDTIPOOCORREVEN_SISTEMA) {
                        $this->removeItem($item);
                    } else {
                        if ($item->getVrreffolha() != 0.0 && $evento->historico->getIdmediavalref() == 'REFERENCIA') {
                            $item->setVreventofolha(0);
                        } elseif (($item->getVreventofolha() == 0.0) && ($item->getVrreffolha() == 0.0)) {
                            $this->removeItem($item);
                        }
                    }
                }
            }
        }
    }

    public function finalizaParcelas($eventom){
        foreach ($this->getItems() as $item) {
            $evento = $eventom->retornaEvento($item->getNreventom());
            $Qtocorproxperi = $item->getQtocorproxperi();

            if (($Qtocorproxperi > 1) &&
                ($item->getIdrefevalorcalc() != self::IDREFEVALORCALC_VALOR)) {
                    $valorTotal = $Qtocorproxperi * $item->getVreventofolha();
                    $item->setVreventofolha($valorTotal);
            }
        }
    }

    public function preparaRecalculo(FpaitecalcfolhaEntity $itens_origem, $eventom){
        foreach ($itens_origem->getItems() as $indice => $item) {
            $evento_aux = $eventom->retornaEvento($item->getNreventom());
            $referencia = $itens_origem->retornaReferencia($indice);
            $valor_item = $itens_origem->retornaValor($indice);
            $dtocorrencia = $itens_origem->retornaDtocorrencia($indice);
            $this->geraEvento($evento_aux, $dtocorrencia, $valor_item, $referencia, 1);
        }
    }

    public function preparaRecalculoProvEventual(FpaitecalcfolhaEntity $itens_origem, $eventom){
        $eventos_transf=array();
        $i=0;
        foreach ($itens_origem->getItems() as $indice => $item_origem) {
            $evento_aux = $eventom->retornaEvento($item_origem->getNreventom());
            if((($evento_aux->getIdtipoevento()==FpaeventomEntity::IDTIPOEVENTO_PROVENTO)
                    && ($evento_aux->historico->getIdtipoocorreven() == FpaeventohEntity::IDTIPOOCORREVEN_EVENTUAL)
                    && ($evento_aux->historico->getIdmediaevenferi() == FpaeventohEntity::IDMEDIAEVENFERI_SIM))
                ||($evento_aux->getIdtipoevento()==FpaeventomEntity::IDTIPOEVENTO_DESCONTO
                    && ($evento_aux->historico->getIdfaltasferias()==FpaeventohEntity::IDFALTASFERIAS_SOMA
                        || $evento_aux->historico->getIdfaltasferias()==FpaeventohEntity::IDFALTASFERIAS_SUBTRAI))
                ||($evento_aux->getNreventom()==FpatipoassoceveEntity::ASSOC_PERDA_RSR_DIA
                    || $evento_aux->getNreventom()==FpatipoassoceveEntity::ASSOC_PERDA_RSR_HORA)
            ){
                $eventos_transf[$i]['NREVENTO']=$item_origem->getNreventom();
                $eventos_transf[$i]['REFERENCIA'] = $itens_origem->retornaReferencia($indice);
                $eventos_transf[$i]['VALOR'] = $itens_origem->retornaValor($indice);
                $eventos_transf[$i]['DTOCORRENCIA'] = $itens_origem->retornaDtocorrencia($indice);
                $i++;
            }
        }
        return $eventos_transf;
    }

    public function calculaDiferencaRecalculo(FpaitecalcfolhaEntity $itens_origem, $eventom,$id_fazDifComp){

        foreach ($itens_origem->getItems() as $indice => $item_origem) {	
            $evento_aux = $eventom->retornaEvento($item_origem->getNreventom());
            $referencia = $itens_origem->retornaReferencia($indice);
            $valor_item = $itens_origem->retornaValor($indice);
            $dtocorrencia = $itens_origem->retornaDtocorrencia($indice);
            $posicao = $this->procuraEvento($evento_aux, null);
            if ($posicao !== -1) {
                $item_corrente = $this->getItem($posicao);
                if ($item_corrente->getIdrefevalorcalc() !== self::IDREFEVALORCALC_VALOR_RECALCULO
                    && $item_corrente->getIdrefevalorcalc() !== self::IDREFEVALORCALC_REFERENCIA_VALOR_RECALCULO
                    && $id_fazDifComp== FpaformrescisaoEntity::ID_FAZDIFERENCACOMP_SIM
                ) {
                    $item_corrente->setVreventofolha($item_corrente->getVreventofolha() - $valor_item);
                    if ($item_corrente->getVreventofolha() < $evento_aux->historico->getVrpisoevento()) {
                        $item_corrente->setVreventofolha($evento_aux->historico->getVrpisoevento());
                    } elseif ($item_corrente->getVreventofolha()> $evento_aux->historico->getVrtetoevento()) {
                        $item_corrente->setVreventofolha($evento_aux->historico->getVrtetoevento());
                    }
                }
                if ((($item_corrente->getVreventofolha() === 0.0)
                    && ($evento_aux->historico->getIdgeravrzero() === FpaeventohEntity::IDGERAVRZERO_NAO))
                    ||  ($id_fazDifComp== FpaformrescisaoEntity::ID_FAZDIFERENCACOMP_NAO
                        && $item_corrente->getIdrefevalorcalc() !== self::IDREFEVALORCALC_VALOR_RECALCULO
                        && $item_corrente->getIdrefevalorcalc() !== self::IDREFEVALORCALC_REFERENCIA_VALOR_RECALCULO
                        && $evento_aux->historico->getIdtipoocorreven() != FpaeventohEntity::IDTIPOOCORREVEN_EVENTUAL
                        && ($evento_aux->getIdtipoevento()==FpaeventomEntity::IDTIPOEVENTO_PROVENTO
                        || $evento_aux->getIdtipoevento()==FpaeventomEntity::IDTIPOEVENTO_DESCONTO)
                    )
                ) {
					if($item_corrente->getNreventom()!= FpatipoassoceveEntity::ASSOC_REFLEXO_REP_REMUNERADO &&
                        $item_corrente->getNreventom()!= FpatipoassoceveEntity::ASSOC_REFLEXO_ADIC_NOTURNO
                    ){
                        $this->removeItem($item_corrente);
                        }
                } else {
                    false;
                }
            }
        }
    }

    public function executaRecalculoMensal(FpaitecalcfolhaEntity $itens_origem, $eventom,$id_fazDifComp){

        foreach ($itens_origem->getItems() as $indice => $item_origem) {

            $evento_aux = $eventom->retornaEvento($item_origem->getNreventom());
            $referencia = $itens_origem->retornaReferencia($indice);
            $valor_item = $itens_origem->retornaValor($indice);
            $dtocorrencia = $itens_origem->retornaDtocorrencia($indice);
            $posicao = $this->procuraEvento($evento_aux, null);
            if ($posicao !== -1) {
                $item_corrente = $this->getItem($posicao);

                if ($item_corrente->getIdrefevalorcalc() !== self::IDREFEVALORCALC_VALOR_RECALCULO
                    && $item_corrente->getIdrefevalorcalc() !== self::IDREFEVALORCALC_REFERENCIA_VALOR_RECALCULO
                    && $id_fazDifComp== FpaformrescisaoEntity::ID_FAZDIFERENCACOMP_SIM
                ) {
                    $item_corrente->setVreventofolha($item_corrente->getVreventofolha() - $valor_item);
                    if ($item_corrente->getVreventofolha() < $evento_aux->historico->getVrpisoevento()) {
                        $item_corrente->setVreventofolha($evento_aux->historico->getVrpisoevento());
                    } elseif ($item_corrente->getVreventofolha()> $evento_aux->historico->getVrtetoevento()) {
                        $item_corrente->setVreventofolha($evento_aux->historico->getVrtetoevento());
                    }
                    if (($item_corrente->getVreventofolha() === 0.0)
                        && ($evento_aux->historico->getIdgeravrzero() === FpaeventohEntity::IDGERAVRZERO_NAO))
                    {
                        $this->removeItem($item_corrente);
                    }

                   }
                $mantem=false;
                if ($id_fazDifComp== FpaformrescisaoEntity::ID_FAZDIFERENCACOMP_NAO){
                    if ($item_corrente->getIdrefevalorcalc() == self::IDREFEVALORCALC_REFERENCIA_VALOR_RECALCULO
                        || $item_corrente->getIdrefevalorcalc() == self::IDREFEVALORCALC_VALOR_RECALCULO
                        || $item_corrente->getIdrefevalorcalc() == self::IDREFEVALORCALC_REFERENCIA_RECALCULO
                        || $item_corrente->getNreventom()== FpatipoassoceveEntity::ASSOC_REFLEXO_REP_REMUNERADO
                        || $item_corrente->getNreventom()== FpatipoassoceveEntity::ASSOC_REFLEXO_ADIC_NOTURNO
                        || $evento_aux->historico->getIdprocdifmovant() == FpaeventohEntity::IDPROCDIFMOVANT_SIM
                    )
                    {
                        $mantem=true;
                    }
                    if( $mantem == false)
                    {
                        $this->removeItem($item_corrente);
                    }
                }
            }
        }
    }

    public function totalizaItensHistorico(
     $vinculo, $lista_nr_calculo_folha, $lista_nr_eventos
    ){
        $lista = array();

        if (empty($lista_nr_eventos) === true) {
            return;
        }

        if (empty($lista_nr_calculo_folha) === true) {
            return;
        }

        $this->retornaItensPorPeriodo(
            $vinculo->getNrorg(), $vinculo->getNrvinculom(), $lista_nr_calculo_folha, $lista_nr_eventos
        );

        $nr_evento_ant = -1;
        $eventom = new FpaeventomEntity($this->entityManager, $this->hcmParameters);
        
        foreach ($this->getItems() as $item) {
            $index = (int)$item->getNreventom();
            if ($item->getNreventom() == FpaTipoassoceveEntity::ASSOC_ADIANT_13SAL) {
                if (array_key_exists($index, $lista)) {
                    continue;
                } else {
                    $lista[$index][self::REFERENCIA] = $item->getVrreffolha();
                    $lista[$index][self::VALOR] = $item->getVreventofolha();
                    continue;
                }
            }
            
            $evento = $eventom->retornaEvento($index);
            
            $vrRefFolha = $item->getVrreffolha();
            
            if($evento->historico->getIdunidrefereven()==FpaeventohEntity::IDUNIDREFEREVEN_HORA_MINUTO){
                $vrRefFolha = FPA::converteHoraDecimal($item->getVrreffolha());
            };
            
            if ($item->getNreventom() != $nr_evento_ant) {
                if ($nr_evento_ant == -1) {
                    $lista[$index][self::REFERENCIA] = $vrRefFolha;
                    $lista[$index][self::VALOR] = $item->getVreventofolha();
                } else {
                    $lista[$index][self::REFERENCIA] += $vrRefFolha;
                    $lista[$index][self::VALOR] += $item->getVreventofolha();
                }
            } else {
                $lista[$index][self::REFERENCIA] += $vrRefFolha;
                $lista[$index][self::VALOR] += $item->getVreventofolha();
            }


            /*if ($item->getNreventom() != $nr_evento_ant) {
                if (array_key_exists($index, $lista)){
                    if ($nr_evento_ant == -1) {
                        $lista[$index][self::REFERENCIA] = $vrRefFolha;
                        $lista[$index][self::VALOR] = $item->getVreventofolha();
                    } else {
                        $lista[$index][self::REFERENCIA] += $vrRefFolha;
                        $lista[$index][self::VALOR] += $item->getVreventofolha();
                    }
                }
            } else {
                if (array_key_exists($index, $lista)){
                    $lista[$index][self::REFERENCIA] += $vrRefFolha;
                    $lista[$index][self::VALOR] += $item->getVreventofolha();
                }
            }*/
            $nr_evento_ant = (int)$item->getNreventom();
        }

        return $lista;
    }

    public function retornaArrayItemCalculo($mes_ocorrencia, $eventom, $vinculo = null, $nrCalcFolha = null, $nmTpCalcMov = null){
        $lista = array();
        $contador = 1;
        $itens	= $this->getItems();
        if (count($itens) === 0) {
            return null;
        }
        $itemDemonstrativo = array();
        foreach ($itens as $key => $item) {
            $evento = $eventom->retornaEvento($item->getNreventom());
            if (is_object($evento) === true) {
                if ($mes_ocorrencia && $item->getDtocorrencia() && $mes_ocorrencia->format('d/m/Y') == DateUtil::getDataDeString($item->getDtocorrencia())->format('d/m/Y')) {
                    $mesOcorrencia = null;
                } else {
                    $mesOcorrencia = $item->getDtocorrencia();
                }
                //Calculo
                if(count($itemDemonstrativo) === 0){
                    $itemDemonstrativo[] = array(
                        'NRORDEIMPRES' => null,
                        'NREVENTOM' => null,
                        'MESOCORRENCIA' => $nrCalcFolha,
                        'TIPOEVENTO' => $nmTpCalcMov,
                        'NRFILHO' => $nrCalcFolha + $vinculo->getNrvinculom(),
                        'NMEVENTOH' => null,
                        'UNIDREFEEVEN' => null,
                        'VRREFFOLHA' => null,
                        'IDEVENDEMON' => null,
                        'VREVENTOFOLHA' => null,
                        'ORDEMTIPOEVENTO' => null,
                        'NRVINCULOM' => null,
                        'NRCALCULOFOLHAVINC' => $vinculo->getNrvinculom()
                    );    
                }
                if($mesOcorrencia){
                    $mesOcorrencia = $mesOcorrencia->format('d/m/Y');
                }
                //Itens
                $itemDemonstrativo[] = array(
                    'NRORDEIMPRES' => $evento->historico->getNrordimpreseven(),
                    'NREVENTOM' => $item->getNreventom(),
                    'MESOCORRENCIA' => $mesOcorrencia,
                    'TIPOEVENTO' => $evento->getIdtipoevento(),
                    'NMEVENTOH' => $evento->historico->getNmeventoh(),
                    'UNIDREFEEVEN' => $evento->historico->getIdunidrefereven(),
                    'VRREFFOLHA' => $item->getVrreffolha(),
                    'IDEVENDEMON' => $item->getIdevendemoncalc(),
                    'VREVENTOFOLHA' => number_format($item->getVreventofolha(), 2, ',','.'),
                    'ORDEMTIPOEVENTO' => $evento->getOrdemTipoEvento($evento->getIdtipoevento()),
                    'NRVINCULOM' => $vinculo->getNrvinculom(),
                    'NRCALCULOFOLHAVINC' => $nrCalcFolha + $vinculo->getNrvinculom()
                );
            } else {
                MsgCalculo::getInstance()->adicionaMensagem('Persiste Item de Calculo: Evento '.$item->getNreventom().' não encontrado para a Organização.');
            }
        }
        sort($itemDemonstrativo);
        return $itemDemonstrativo;
    }

    public function retornaItensPorPeriodo($nr_org, $nr_vinculo, $lista_nr_calculo, $lista_nr_evento){

        $this->resetItems();
        $resultado = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->retornaItemPeriodo($nr_org, $nr_vinculo, $lista_nr_calculo, $lista_nr_evento);
        
        if (count($resultado) > 0) {
            foreach ($resultado as $entity_obj) {
                $this->addItem($entity_obj);
            }
        }
    }

    public function incluiIteCalcFolha(
        $nrCalculo, $nrVinculo, $nrEvento, $nrOrg, $idEventoDemonstrativo, $referencia, $valor,
        $idReferenciaValor, $qtdOcorrencia, $dtOcorrencia
    ){
        $item = new self();
        $item->setNrcalculofolha($nrCalculo);
        $item->setNrvinculom($nrVinculo);
        $item->setNreventom($nrEvento);
        $item->setNrorg($nrOrg);
        $item->setIdevendemoncalc($idEventoDemonstrativo);
        $item->setVrreffolha($referencia);
        $item->setVreventofolha($valor);
        $item->setQtocorproxperi($qtdOcorrencia);
        $item->setIdrefevalorcalc($idReferenciaValor);
        $item->setDtocorrencia($dtOcorrencia);

        $this->addItem($item);
    }

    public function pesquisaEvento($nrOrg, $nrVinculo, $nrCalculoFolha, $nrTipoAssoc){
        $resultado = Fpaitecalcfolha::pesquisaEventoPorTipoAssoc(
            $nrOrg, $nrVinculo, $nrCalculoFolha, $nrTipoAssoc
        );
        if (count($resultado) > 0) {
            return true;
        } else {
            return false;
        }
    }

    public function insereItemCalculoFolha($nrorg, $nrcalculo, $nrvinculo, $nrevento, $dtocorrencia, $idevendemoncalc,
                                           $referencia, $valor, $qtdOcorrencia, $idReferenciaValor)
    {
        $this->setNrorg($nrorg);
        $this->setNrcalculofolha($nrcalculo);
        $this->setNrvinculom($nrvinculo);
        $this->setNreventom($nrevento);
        $this->setDtocorrencia($dtocorrencia);
        $this->setIdevendemoncalc($idevendemoncalc);
        $this->setVrreffolha($referencia);
        $this->setVreventofolha($valor);
        $this->setQtocorproxperi($qtdOcorrencia);
        $this->setIdrefevalorcalc($idReferenciaValor);
    }

    public function getEvento()
    {
        if (!$this->evento) {
            $this->evento = FpaeventomEntity::getEvento($this->getNreventom());
        }
        return $this->evento;
    }

    public static function getItensCalculoFolha($nrorg, $nrcalculofolha)
    {
        $fpaitecalcfolha = self::getEntitiesByWhere(
            'NRORG = ? AND NRCALCULOFOLHA = ?', array($nrorg, $nrcalculofolha)
        );
        return $fpaitecalcfolha;
    }

    public static function getItemCalculoPorChaveUnica($nrorg, $nrcalculo, $nrvinculom, $nreventom,
                                                                       $dtocorrencia)
    {
        $params = array($nrorg, $nrcalculo, $nrvinculom, $nreventom, $dtocorrencia);
        $fpaitecalcfolha = self::getEntityByWhere(
            'NRORG = ? AND NRCALCULOFOLHA = ? AND NRVINCULOM = ? AND NREVENTOM = ? AND DTOCORRENCIA = ?', $params
        );
        return $fpaitecalcfolha;
    }

    public static function getItemCalculoPorVinculoDtOcor($nrorg, $nrvinculom, $nreventom,
                                                       $dtocorrencia)
    {
        $params = array($nrorg, $nrvinculom, $nreventom, $dtocorrencia);
        $fpaitecalcfolha = self::getEntityByWhere(
            'NRORG = ? AND NRVINCULOM = ? AND NREVENTOM = ? AND DTOCORRENCIA = ?', $params
        );
        return $fpaitecalcfolha;
    }

    public function alteratributoitem($eventom,$atributo,$valorAtributo){

        foreach ($this->getItems() as $indice => $item_corrente) {
            $posicao = $this->procuraEvento($eventom, null);
            if ($posicao !== -1) {									
                $item_corrente = $this->getItem($posicao);

                if ($item_corrente->getIdrefevalorcalc() !== self::IDREFEVALORCALC_REFERENCIA_VALOR
                ) {							
					$item_corrente->setVrreffolha($valorAtributo);
				}	
            }
        }
    }

    public function retiraitem($eventom){
        foreach ($this->getItems() as $indice => $item_corrente) {
            $posicao = $this->procuraEvento($eventom, null);
            if ($posicao !== -1) {
                $item_corrente = $this->getItem($posicao);
                $this->removeItem($item_corrente);
            }
        }
    }
    
    public function setNrTipoCalculo($nrTipoCalculo){
        $this->_nrTipoCalculo = $nrTipoCalculo;
    }
    
    public function setNrcalculofolha($nrCalculofolha){
        $this->nrCalculofolha = $nrCalculofolha;
    }
    
    public function setNrvinculom($nrVinculom){
        $this->nrVinculom = $nrVinculom;
    }
    
    public function getNrcalculofolha(){
        return $this->nrCalculofolha;
    }

}