 <?php
namespace HCM\Geral\Controllers;

use \Zeedhi\Framework\DTO\Response;
use \Zeedhi\Framework\DTO\Response\Message;

class HcmLogController extends \Zeedhi\Framework\Controller\Simple {

    protected $hcmLogService;

    public function __construct(\Service\HcmLogService $hcmLogService) {
        $this->hcmLogService = $hcmLogService;
    }

    public function executeQuery($request, $response) {
        try {

            $filters = $request->getFilterCriteria()->getConditions();
            $parameters = array();
            foreach ($filters as $filter) {
                unset($filter['operator']);
                foreach ($filter as $key => $value) {
                    if ($key == 'columnName') {
                        $parameters[$value] = $filter['value'];
                        unset($filter['columnName']);
                    }
                }
            }

            $result = $this->hcmLogService->execute($parameters);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('result', $result));

        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }
}