<?php
namespace HCM\Geral\Repository\Esocial;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class S2299Repository {

    protected  $connection;

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function getItensParaEnvioS2299($params) {
        $sql = <<<SQL
SELECT VH.NRVINCULOM as NRCHAVE,
       VH.NRVINCULOM,
       'I' as IDOPERACAO,
       NVL(MS.DTFIMMOVIMENT,VM.DTRESCISAOVINC) as DTMESCOMPETENC
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = ( SELECT *
                                              FROM ( SELECT DTMESCOMPETENC
                                                     FROM GPE_VINCULOH
                                                     WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                       AND NRORG      = VH.NRORG
                                                       AND NRVINCULOM = VH.NRVINCULOM
                                                     ORDER BY DTMESCOMPETENC DESC )
                                               WHERE ROWNUM = 1 )
   LEFT JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                          AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                          AND EH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                     WHERE H1.NRORG = EH.NRORG
                                                       AND H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                       AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
   /*Transferencia de saida*/
   LEFT JOIN GPE_MOVIMENTACAO MS ON MS.NRORG = VM.NRORG
                                AND MS.NRVINCULOM = VM.NRVINCULOM
                                AND MS.NRESTRUTURAM = VH.NRESTRUTLEGAL
                                AND MS.NRTPMOVTRANSFM = 9
                                AND MS.DTFIMMOVIMENT BETWEEN ADD_MONTHS(:P_DTMESCOMPETENC, '-1') AND LAST_DAY(:P_DTMESCOMPETENC)
   LEFT JOIN ESTRUTURAH ES ON ES.NRORG = MS.NRORG
                          AND ES.NRESTRUTURAM = MS.NRESTRUTURAM
                          AND ES.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                     WHERE H1.NRORG = ES.NRORG
                                                       AND H1.NRESTRUTURAM = ES.NRESTRUTURAM
                                                       AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
   /*Transferencia de entrada*/
   LEFT JOIN GPE_MOVIMENTACAO ME ON ME.NRORG = MS.NRORG
                                AND ME.NRVINCULOM = MS.NRVINCULOM
                                AND ME.NRTIPOTRANSFER = MS.NRTIPOTRANSFER
                                AND ME.NRTIPOESTRUTURA = MS.NRTIPOESTRUTURA
                                AND ME.NRTPMOVTRANSFM = 8
                                AND ME.DTINIMOVIMENT > MS.DTFIMMOVIMENT
   LEFT JOIN ESTRUTURAH EE ON EE.NRORG = ME.NRORG
                          AND EE.NRESTRUTURAM = ME.NRESTRUTURAM
                          AND EE.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                     WHERE H1.NRORG = EE.NRORG
                                                       AND H1.NRESTRUTURAM = EE.NRESTRUTURAM
                                                       AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   /*Rescindidos ou transferidos para outro empregador*/
   AND ((SUBSTR(REPLACE(REPLACE(REPLACE(EH.CDCNPJESTRUT,'.'),'/'),'-'),1,8) = SUBSTR(REPLACE(REPLACE(REPLACE(:P_CDCNPJEMPREGADOR,'.'),'/'),'-'),1,8) AND VM.DTRESCISAOVINC BETWEEN ADD_MONTHS(:P_DTMESCOMPETENC, '-1') AND LAST_DAY(:P_DTMESCOMPETENC)) OR
        (MS.NRMOVIMENTACAO IS NOT NULL AND SUBSTR(REPLACE(REPLACE(REPLACE(EE.CDCNPJESTRUT,'.'),'/'),'-'),1,8) <> SUBSTR(REPLACE(REPLACE(REPLACE(ES.CDCNPJESTRUT,'.'),'/'),'-'),1,8)))
   AND (EXISTS (SELECT 1 
                 FROM FPA_ITECALCFOLHA ITC
                 JOIN FPA_CALCULOFOLHA CFL ON CFL.NRORG = ITC.NRORG
                                          AND CFL.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                          AND CFL.NRTIPOMOVIMENT = 1
                                          AND CFL.NRTPMODALIDCAL = 1
            LEFT JOIN ESO_PARAMETRO ESOPARAMS ON ESOPARAMS.NRESTRUTURAM = VH.NRESTRUTLEGAL
                                             AND ESOPARAMS.NRORG = VH.NRORG 
                WHERE ITC.NRVINCULOM = VH.NRVINCULOM
                  AND ITC.NRORG = VH.NRORG
                  AND ITC.NREVENTOM = '3050'
                  AND CFL.DTOCORRENCIA = (SELECT MAX(CF.DTOCORRENCIA)
                                            FROM FPA_ITECALCFOLHA IT
                                            JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                                                                    AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                                                                    AND CF.NRTIPOMOVIMENT = 1
                                                                    AND CF.NRTPMODALIDCAL = 1
                                           WHERE IT.NRORG      = ITC.NRORG
                                             AND IT.NRVINCULOM = ITC.NRVINCULOM
                                             AND IT.NREVENTOM = '3050'
                                             AND IT.DTOCORRENCIA <= ADD_MONTHS(LAST_DAY(VM.DTRESCISAOVINC),1)) 
                  AND((ESOPARAMS.IDAPROVACALCRESC = 'S'AND EXISTS(SELECT 1
                                                                    FROM FPA_ITECALCFOLHA ITFEC 
                                                                   WHERE ITFEC.NRORG = ITC.NRORG
                                                                     AND ITFEC.NRVINCULOM = ITC.NRVINCULOM
                                                                     AND ITFEC.NREVENTOM = 3035
                                                                     AND ITFEC.NRCALCULOFOLHA = CFL.NRCALCULOFOLHA)) OR NVL(ESOPARAMS.IDAPROVACALCRESC, 'N') = 'N')) OR MS.DTFIMMOVIMENT IS NOT NULL)
   AND VM.NRTIPOVINCULOM = 1 /*CLT*/
   AND (VM.NRVINCULOM = :P_NRVINCULOM OR :P_NRVINCULOM IS NULL)
   AND (NVL(MS.DTFIMMOVIMENT,VM.DTRESCISAOVINC) >= :P_DTREFNAOPERIOD OR :P_DTREFNAOPERIOD IS NULL)
 ORDER BY 4,1
SQL;

        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => array_key_exists('DTMESCOMPETENCIA', $params) ? $params['DTMESCOMPETENCIA'] : $this->hcmParameters->getDtCompetencia(),
            "P_CDCNPJEMPREGADOR" => isset($params['CDCNPJEMPREGADOR']) ? $params['CDCNPJEMPREGADOR'] : null,
            "P_NRVINCULOM" => isset($params['NRVINCULOM']) ? $params['NRVINCULOM'] : null,
            "P_DTREFNAOPERIOD" => isset($params['DTREFNAOPERIOD']) ? $params['DTREFNAOPERIOD'] : null,
        );
        
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS2299($params) {
        try {
            $dados = $this->getDadosPrincipais($params['NRENVIO'], $params['NRCHAVE'], $params['NRESTRUTURAM'], $params['NRTPAMBIENTE'], $params['CDCNPJEMPREGADOR']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function getDadosPrincipais($nrenvio, $nrchave, $nrestruturam, $nrtpambiente, $cdcnpjempregador) {
        $sql = <<<SQL
/*getDadosS2299*/
SELECT VM.NRVINCULOM CHAVE,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') TPINSC,
       CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END NRINSC,    
       --ideVinculo
       REPLACE(REPLACE(PH.NRCPFPESSOA,'.'),'-') AS CPFTRAB,
       NVL(VH.CDMATRICULAESOCIAL, VM.NRVINCULOM) AS matricula,
       --infoDeslig
       DECODE(MOH.NRESTRUTURAM,NULL,TD.CDESOCIAL,DECODE(TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM'),TO_CHAR(TO_DATE(:P_DTMESCOMPETENC),'YYYY-MM'),TD.CDESOCIAL, '13')) AS mtvDeslig,
       TO_CHAR(DECODE(MOH.NRESTRUTURAM,NULL,VM.DTRESCISAOVINC,DECODE(TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM'),TO_CHAR(TO_DATE(:P_DTMESCOMPETENC),'YYYY-MM'),VM.DTRESCISAOVINC, MO.DTFIMMOVIMENT)),'YYYY-MM-DD') AS dtDeslig,
       DECODE(MOH.NRESTRUTURAM,NULL,DECODE(VM.DTAVISOPREVIO, NULL, '', TO_CHAR(VM.DTAVISOPREVIO,'YYYY-MM-DD')),NULL) AS dtAvPrv,
       DECODE(MOH.NRESTRUTURAM,NULL,DECODE(VM.DTRESCISAOVINC, VM.DTAVISOPREVIO, 'S', 'N'), DECODE(TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM'),TO_CHAR(TO_DATE(:P_DTMESCOMPETENC),'YYYY-MM'),DECODE(VM.DTRESCISAOVINC, VM.DTAVISOPREVIO, 'S', 'N'),'N')) indPagtoAPI,       
       DECODE(MOH.NRESTRUTURAM,NULL,DECODE(VM.DTRESCISAOVINC, VM.DTAVISOPREVIO, TO_CHAR(VM.DTAVISOPREVIO,'YYYY-MM-DD'), NULL),DECODE(TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM'),TO_CHAR(TO_DATE(:P_DTMESCOMPETENC),'YYYY-MM'),DECODE(VM.DTRESCISAOVINC, VM.DTAVISOPREVIO, TO_CHAR(VM.DTAVISOPREVIO,'YYYY-MM-DD'), NULL), NULL)) AS dtProjFimAPI,
       CASE WHEN ITC.VRPENSAO > 0 THEN 2 ELSE 0 END AS pensAlim,
       NULL AS percAliment,
       CASE WHEN ITC.VRPENSAO > 0 THEN ROUND(ITC.VRPENSAO,2) ELSE NULL END AS vrAlim,
       VM.NRPROCJUD AS nrProcTrab,
       --infoInterm getDadosS2299infoInterm
       --observacoes getDadosS2299observacoes
       --sucessaoVinc 
       DECODE(MOH.NRESTRUTURAM,NULL,NULL,DECODE(TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM'),TO_CHAR(TO_DATE(:P_DTMESCOMPETENC),'YYYY-MM'),NULL, DECODE(MLP.CDTIPOINSCRICAO,'CNPJ','1','CPF','2',''))) tpInsc_sucessaoVinc,
       DECODE(MOH.NRESTRUTURAM,NULL,NULL,DECODE(TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM'),TO_CHAR(TO_DATE(:P_DTMESCOMPETENC),'YYYY-MM'),NULL, MLH.CDCNPJESTRUT)) nrInsc_sucessaoVinc,
       --transfTit
       null cpfSubstituto,
       null dtNascto,
       --mudancaCPF
       null novoCPF,
       --verbasResc
       --dmDev getDadosS2299dmDev       
       --ideEstabLot getDadosS2299ideEstabLot       
       --detVerbas getDadosS2299detVerbas       
       --detOper getDadosS2299detOper       
       --detPlano getDadosS2299detPlano       
       --procJudTrab getDadosS2299procJudTrab     
       --infoMV
       --getDadosS2299remunOutrEmpr
       DECODE(OV.VREVENTOFOLHA, NULL, NULL, DECODE(VH.IDMULTVINC, 'PRIMARIO', '1', '3')) indMV,
       null dtFimQuar,
       'N' idConsig,
       '' insConsig,
       '' nrContr,
       VM.NRORG, VM.NRVINCULOM, DECODE(MO.NRMOVIMENTACAO,NULL,VM.DTRESCISAOVINC,MO.DTFIMMOVIMENT) AS DTRESCISAOVINC, VM.NRPESSOA, PE.NRPARCNEGOCIO, VH.NRESTRUTLEGAL, VH.NRESTRUTGEREN, CE.CDESOCIAL CDCATEGTRAB, 
       :P_NRTPAMBIENTE NRTPAMBIENTE, DECODE(:P_NRTPAMBIENTE, 1, DECODE(EMP.NRGRUPOESOCIAL, 3, :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR) INIVALIDADEAMB, :P_DTMESCOMPETENC DTMESCOMPETENC,
       VH.NRAGENTENOCIVO, VM.NRTIPOVINCULOM
  FROM GPE_VINCULOM VM
  /*Dados do Empregado - Vínculo*/
  JOIN GPE_VINCULOH VH
    ON VH.NRVINCULOM = VM.NRVINCULOM
   AND VH.NRORG      = VM.NRORG
   AND VH.DTMESCOMPETENC = ( SELECT *
                                              FROM ( SELECT DTMESCOMPETENC
                                                     FROM GPE_VINCULOH
                                                     WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                       AND NRORG      = VH.NRORG
                                                       AND NRVINCULOM = VH.NRVINCULOM
                                                     ORDER BY DTMESCOMPETENC DESC )
                                               WHERE ROWNUM = 1 )
  /*Dados do Empregado - Pessoa*/                               
  JOIN GPE_PESSOA PE
    ON PE.NRPESSOA = VM.NRPESSOA
   AND PE.NRORG    = VM.NRORG
  JOIN GPE_PESSOAH PH
    ON PH.NRPESSOA = PE.NRPESSOA
   AND PH.NRORG    = PE.NRORG
   AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                             WHERE GPE_PESSOAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                               AND GPE_PESSOAH.NRPESSOA = PE.NRPESSOA
                               AND GPE_PESSOAH.NRORG = PE.NRORG)
  JOIN PARCNEGOCIO PN
    ON PN.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
   AND PN.NRORG         = PE.NRORG                               
  
  /*Empregador*/
  JOIN ESTRUTURAM EMP ON EMP.NRORG = :P_NRORG
                     AND EMP.NRESTRUTURAM = :P_NRESTRUTURAM
  LEFT JOIN ESTRUTURAH EMH ON EMH.NRORG = EMP.NRORG
                     AND EMH.NRESTRUTURAM = EMP.NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND ESTRUTURAH.NRESTRUTURAM = EMH.NRESTRUTURAM
                                                 AND ESTRUTURAH.NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
  /*Categoria Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  /*Demissao*/
  LEFT JOIN FPA_TPDEMISSAO TD ON VM.NRTPDEMISSAO = TD.NRTPDEMISSAO 
                             AND (TD.NRORG = :P_NRORG OR TD.NRORG = 0)
  /*Pensão*/  
  LEFT JOIN (SELECT ITC.NRORG, ITC.NRVINCULOM, SUM(ITC.VREVENTOFOLHA) VRPENSAO
               FROM FPA_ITECALCFOLHA ITC
              WHERE ITC.NRORG = :P_NRORG
                AND ITC.NRVINCULOM = :P_NRCHAVE
                AND ITC.NRCALCULOFOLHA = (SELECT CF.NRCALCULOFOLHA
                                            FROM FPA_CALCULOFOLHA CF
                                           WHERE CF.NRORG = ITC.NRORG
                                             AND CF.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                             AND CF.NRTPMODALIDCAL = 1
                                             AND CF.NRTIPOMOVIMENT = 1
                                             AND CF.DTOCORRENCIA = (SELECT MAX(C.DTOCORRENCIA)
                                                                      FROM FPA_ITECALCFOLHA I
                                                                      JOIN GPE_VINCULOM V ON V.NRORG = I.NRORG
                                                                                         AND V.NRVINCULOM = I.NRVINCULOM
                                                                      JOIN FPA_CALCULOFOLHA C ON C.NRORG = I.NRORG
                                                                                             AND C.NRCALCULOFOLHA = I.NRCALCULOFOLHA
                                                                                             AND C.NRTIPOMOVIMENT = 1
                                                                                             AND C.NRTPMODALIDCAL = 1
                                                                     WHERE I.NRORG = :P_NRORG
                                                                       AND I.NRVINCULOM = :P_NRCHAVE
                                                                       AND I.NREVENTOM = '3050'
                                                                       AND I.DTOCORRENCIA <= ADD_MONTHS(LAST_DAY(V.DTRESCISAOVINC),1)))
                AND ITC.NREVENTOM IN (SELECT IE.NREVENTOM
                                        FROM FPA_INCIDEVENTO IE
                                       WHERE (IE.NRORG = ITC.NRORG OR IE.NRORG = 0)
                                         AND IE.NRTIPOINCIDE IN (76,132)) /*DIRF - RTPA, INCIDE PENSAO FERIAS*/
              GROUP BY ITC.NRORG, ITC.NRVINCULOM) ITC ON ITC.NRORG = VM.NRORG
                                                     AND ITC.NRVINCULOM = VM.NRVINCULOM
  /*Remuneração Outra Empresa*/
  LEFT JOIN (SELECT OV.NRORG, OV.NRVINCULOM, OV.NRPESSOA, SUM(ITC.VREVENTOFOLHA) VREVENTOFOLHA
               FROM GPE_VINCULOM OV
               JOIN FPA_ITECALCFOLHA ITC ON ITC.NRORG = OV.NRORG
                                        AND ITC.NRVINCULOM = OV.NRVINCULOM
                                        AND ITC.NREVENTOM = 3050
                                        AND ITC.VREVENTOFOLHA > 0
               JOIN FPA_CALCULOFOLHA CF ON CF.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                       AND CF.NRORG = ITC.NRORG
                                       AND CF.NRTIPOMOVIMENT = 1
                                       AND CF.NRTPMODALIDCAL = 1
                                       AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
              WHERE OV.NRORG = :P_NRORG
                --AND OV.NRVINCULOM = P_NRCHAVE
              GROUP BY OV.NRORG, OV.NRVINCULOM, OV.NRPESSOA) OV ON OV.NRORG = VM.NRORG
                                                               AND OV.NRPESSOA = VM.NRPESSOA
                                                               AND OV.NRVINCULOM <> VM.NRVINCULOM
  /*Caso tenha movimentação de transferencia de saida*/
  LEFT JOIN GPE_MOVIMENTACAO MO ON MO.NRORG = VM.NRORG
                               AND MO.NRVINCULOM = VM.NRVINCULOM
                               AND MO.NRTPMOVTRANSFM = 9
                               AND MO.DTFIMMOVIMENT BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)                           
  LEFT JOIN ESTRUTURAH MOH ON MOH.NRORG = MO.NRORG
                          AND MOH.NRESTRUTURAM = MO.NRESTRUTURAM
                          AND SUBSTR(MOH.CDCNPJESTRUT,1,8) = SUBSTR(:P_CDCNPJEMPREGADOR,1,8)
                          AND MOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                     WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                       AND ESTRUTURAH.NRESTRUTURAM = MOH.NRESTRUTURAM
                                                       AND SUBSTR(ESTRUTURAH.CDCNPJESTRUT,1,8) = SUBSTR(:P_CDCNPJEMPREGADOR,1,8)
                                                       AND ESTRUTURAH.NRORG = MOH.NRORG)
  /*Movimentação de admissão proveniente de transferencia*/
  LEFT JOIN GPE_MOVIMENTACAO ML ON ML.NRORG = MO.NRORG
                               AND ML.NRVINCULOM = MO.NRVINCULOM
                               AND ML.NRTIPOTRANSFER = MO.NRTIPOTRANSFER
                               AND ML.NRTIPOESTRUTURA = MO.NRTIPOESTRUTURA
                               AND ML.NRTPMOVTRANSFM = 8
                               AND ML.DTINIMOVIMENT > MO.DTFIMMOVIMENT
  LEFT JOIN ESTRUTURAH MLH ON MLH.NRORG = ML.NRORG
                          AND MLH.NRESTRUTURAM = ML.NRESTRUTURAM
                          AND MLH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                     WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                       AND ESTRUTURAH.NRESTRUTURAM = MLH.NRESTRUTURAM
                                                       AND ESTRUTURAH.NRORG = MLH.NRORG)
  LEFT JOIN PARCNEGOCIO MLP ON MLP.NRORG = MLH.NRORG
                           AND MLP.NRPARCNEGOCIO = MLH.NRPARCNEGOCIO
 WHERE VM.NRORG = :P_NRORG
   AND VM.NRVINCULOM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_INIVALIDADEAMBP" => $this->hcmParameters->getEsoIniValidPeriodProducao(),
            "P_INIVALIDADEAMBPR" => $this->hcmParameters->getEsoIniValidPeriodProdRest(),
            "P_INIVALIDADEAMBNS" => $this->hcmParameters->getEsoIniValidPeriodNacioSimples(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_CDCNPJEMPREGADOR" => $cdcnpjempregador,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }
    
    public function getDadosS2299infoInterm($params) {
        if ($params['CDCATEGTRAB'] == '111') {
            
            $valida = null;
            $sql = <<<SQL
SELECT VM.NRDIASAPURVALES, COUNT(DT.DTDATA) AS DIA
  FROM GPE_CONVOCACAO CO
  JOIN DATA DT ON DT.DTDATA BETWEEN CO.DTINICONVOCACAO AND CO.DTFIMCONVOCACAO
  JOIN GPE_VINCULOM VM ON VM.NRORG = CO.NRORG
                      AND VM.NRVINCULOM = CO.NRVINCULOM
 WHERE CO.NRORG = :P_NRORG
   AND CO.NRVINCULOM = :P_NRVINCULOM
   AND :P_CDCATEGTRAB = '111'
   AND DT.DTDATA BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)
 GROUP BY VM.NRDIASAPURVALES
SQL;
            $params = array(
                "P_NRORG" => $params['NRORG'],
                "P_NRVINCULOM" => $params['NRVINCULOM'],
                "P_CDCATEGTRAB" => $params['CDCATEGTRAB'],
                "P_DTMESCOMPETENC" => $params['DTMESCOMPETENC'],
            );
            $valida = $this->connection->fetchAssoc($sql, $params);
            
            if ($valida && $valida['NRDIASAPURVALES'] == 0 && $valida['DIA'] > 0) {
                return array();
            } else {
                $dados = $this->getDadosInfoInterm($params['NRORG'], $params['NRVINCULOM'], $params['CDCATEGTRAB'], $params['DTMESCOMPETENC']);
                return $dados;
            }
        } else {
            return array();
        }
    }
    
    public function getDadosInfoInterm($nrorg, $nrvinculom, $cdcategtrab, $dtmescompetenc) {
        $sql = <<<SQL
/*getDadosS2299infoInterm*/
--SELECT TO_NUMBER(TO_CHAR(DT.DTDATA,'DD')) AS DIA
SELECT COUNT(DT.DTDATA) AS DIA
  FROM GPE_CONVOCACAO CO
  JOIN DATA DT ON DT.DTDATA BETWEEN CO.DTINICONVOCACAO AND CO.DTFIMCONVOCACAO
 WHERE CO.NRORG = :P_NRORG
   AND CO.NRVINCULOM = :P_NRVINCULOM
   AND :P_CDCATEGTRAB = '111'
   AND DT.DTDATA BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)
 ORDER BY 1
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRVINCULOM" => $nrvinculom,
            "P_CDCATEGTRAB" => $cdcategtrab,
            "P_DTMESCOMPETENC" => $dtmescompetenc,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS2299observacoes($params) {
        $dados = $this->getDadosObservacoes($params['NRORG'], $params['NRVINCULOM']);
        return $dados;
    }
    
    public function getDadosObservacoes($nrorg, $nrvinculom) {
        $sql = <<<SQL
/*getDadosS2299observacoes*/
SELECT VM.DSOBSRESCISAO AS observacao
  FROM GPE_VINCULOM VM
 WHERE VM.NRVINCULOM = :P_NRVINCULOM
   AND VM.NRORG = :P_NRORG
   AND VM.DSOBSRESCISAO IS NOT NULL
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRVINCULOM" => $nrvinculom,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS2299dmDev($params) {
        $dados = $this->getDadosDmDev(
            $params['NRORG'], $params['NRVINCULOM'], $params['DTRESCISAOVINC'], $params['NRESTRUTLEGAL'], $params['NRESTRUTGEREN'], $params['CDCATEGTRAB'], $params['NRTPAMBIENTE'], $params['MTVDESLIG'], $params['INIVALIDADEAMB'], $params['NRPESSOA'], $params['NRINSC'], $params['DTMESCOMPETENC'], $params['NRAGENTENOCIVO'], $params['NRTIPOVINCULOM']
        );
        return $dados;
    }
    
    public function getDadosDmDev($nrorg, $nrvinculom, $dtrescisao, $nrestrutlegal, $nrestrutgeren, $cdcategtrab, $nrtpambiente, $mtvDeslig, $inivalidadeamb, $nrpessoa, $nrinsc, $dtmescompetenc, $nragentenocivo, $nrtipovinculom) {
        $sql = <<<SQL
/*getDadosS2299dmDev*/
SELECT :P_NRTIPOVINCULOM||'.'||:P_CDCATEGTRAB||'.'||ITC.NRCALCULOFOLHA AS ideDmDev,
       ITC.NRORG, ITC.NRVINCULOM, ITC.NRCALCULOFOLHA, :P_NRESTRUTLEGAL NRESTRUTLEGAL, :P_NRESTRUTGEREN NRESTRUTGEREN, :P_CDCATEGTRAB CDCATEGTRAB, :P_DTMESCOMPETENC DTMESCOMPETENC, :P_NRAGENTENOCIVO NRAGENTENOCIVO
  FROM FPA_ITECALCFOLHA ITC
  JOIN FPA_CALCULOFOLHA CFL ON CFL.NRORG = ITC.NRORG
                           AND CFL.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                           AND CFL.NRTIPOMOVIMENT IN (1,2,4,10,19)
                           AND CFL.NRTPMODALIDCAL = 1
 WHERE ITC.NRVINCULOM = :P_NRCHAVE
   AND ITC.NRORG = :P_NRORG
   AND ((CFL.NRTIPOMOVIMENT = 1 AND ITC.NREVENTOM = '3050' AND CFL.DTOCORRENCIA = (SELECT MAX(CF.DTOCORRENCIA)
                                                                                     FROM FPA_ITECALCFOLHA IT
                                                                                     JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                                                                                                             AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                                                                                                             AND CF.NRTIPOMOVIMENT = CFL.NRTIPOMOVIMENT
                                                                                                             AND CF.NRTPMODALIDCAL = 1
                                                                                    WHERE IT.NRORG      = ITC.NRORG
                                                                                      AND IT.NRVINCULOM = ITC.NRVINCULOM
                                                                                      AND IT.NREVENTOM = ITC.NREVENTOM
                                                                                      AND CF.DTOCORRENCIA <= FIRST_DAY(:P_DTRESCISAOVINC)))
        OR (CFL.NRTIPOMOVIMENT = 1 AND ITC.NREVENTOM = '3030' AND CFL.DTOCORRENCIA = FIRST_DAY(:P_DTRESCISAOVINC) AND CFL.NROCORRECAL > 1)
        OR (CFL.NRTIPOMOVIMENT = 2 AND ITC.NREVENTOM = '3030' AND CFL.DTOCORRENCIA = FIRST_DAY(:P_DTRESCISAOVINC))
        OR (CFL.NRTIPOMOVIMENT = 10 AND ITC.NREVENTOM = '3030' AND CFL.DTOCORRENCIA = FIRST_DAY(:P_DTRESCISAOVINC))
        OR (CFL.NRTIPOMOVIMENT = 19 AND ITC.NREVENTOM = '3030' AND CFL.DTOCORRENCIA = FIRST_DAY(:P_DTRESCISAOVINC))
        OR (CFL.NRTIPOMOVIMENT = 4 AND ITC.NREVENTOM = '3030' AND CFL.DTOCORRENCIA = FIRST_DAY(:P_DTRESCISAOVINC) AND SUBSTR(CFL.DTOCORRENCIA, 3, 2) <> '12'))
   AND TO_DATE(:P_DTRESCISAOVINC) >= :P_INIVALIDADEAMB
   AND :P_MTVDESLIG NOT IN ('11','12','13','25','28','29','30','34','36')
   AND ((NOT EXISTS (SELECT 1 /*SE EXISTIR EVENTO S-1200 DE 13o NAO ENVIA O DEMONSTRATIVO DE 13o JUNTO COM A RESCISAO*/
                       FROM ESO_ENVIOCADASTROS EC
                       JOIN ESTRUTURAH ESH ON ESH.NRORG = EC.NRORG
                                          AND ESH.NRESTRUTURAM = EC.NRESTRUTURAM
                                          AND SUBSTR(ESH.CDCNPJESTRUT, 1, 8) =  SUBSTR(:P_NRINSC, 1,8)
                                          AND ESH.DTMESCOMPETENC = (SELECT MAX(ESHH.DTMESCOMPETENC)
                                                                      FROM ESTRUTURAH ESHH
                                                                     WHERE ESHH.NRORG = ESH.NRORG
                                                                       AND ESHH.NRESTRUTURAM = ESH.NRESTRUTURAM
                                                                       AND ESHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                      WHERE EC.NRORG = :P_NRORG
                        AND EC.IDSTATUS IN ('C', 'A')
                        AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
                        AND EC.NRCHAVE = :P_NRPESSOA
                        AND EC.NRTABELA = 4
                        AND TRUNC(TO_DATE(EC.DTMESCOMPETENC), 'YEAR') = TRUNC(TO_DATE(:P_DTMESCOMPETENC), 'YEAR')
                        AND EC.NRENVIOEXCL IS NULL
                        AND EC.IDATIVO = 'S'
                        AND EC.NREVENTO IN (SELECT SE.NREVENTO
                                              FROM ESO_EVENTO SE
                                             WHERE SE.NMEVENTO = 'S-1200')
                     UNION ALL
                     SELECT 1  /*SE EXISTIR EVENTO S-1200 DE 13o NAO ENVIA O DEMONSTRATIVO DE 13o JUNTO COM A RESCISAO*/
                       FROM ESO_PERIODICO EC
                       JOIN ESTRUTURAH ESH ON ESH.NRORG = EC.NRORG
                                          AND ESH.NRESTRUTURAM = EC.NRESTRUTURAM
                                          AND SUBSTR(ESH.CDCNPJESTRUT, 1, 8) =  SUBSTR(:P_NRINSC, 1,8)
                                          AND ESH.DTMESCOMPETENC = (SELECT MAX(ESHH.DTMESCOMPETENC)
                                                                      FROM ESTRUTURAH ESHH
                                                                     WHERE ESHH.NRORG = ESH.NRORG
                                                                       AND ESHH.NRESTRUTURAM = ESH.NRESTRUTURAM
                                                                       AND ESHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                      WHERE EC.NRORG = :P_NRORG
                        AND EC.IDSTATUS IN ('C', 'A')
                        AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
                        AND EC.NRCHAVE = :P_NRPESSOA
                        AND EC.NRTABELA = 4
                        AND TRUNC(TO_DATE(EC.DTMESCOMPETENC), 'YEAR') = TRUNC(TO_DATE(:P_DTMESCOMPETENC), 'YEAR')
                        AND EC.NRENVIOEXCL IS NULL
                        AND EC.IDATIVO = 'S'
                        AND EC.NMEVENTO = 'S-1200') AND CFL.NRTIPOMOVIMENT = 4) OR CFL.NRTIPOMOVIMENT <> 4)
   AND EXISTS (SELECT 1
                 FROM FPA_ITECALCFOLHA IT
                 JOIN FPA_CALCULOFOLHA CF ON IT.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                                         AND CF.NRORG = IT.NRORG
                 JOIN FPA_EVENTOH EH ON EH.NREVENTOM = IT.NREVENTOM
                                    AND (EH.NRORG = :P_NRORG OR EH.NRORG = 0)
                                    AND EH.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                               WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                 AND EHH.NREVENTOM = EH.NREVENTOM
                                                                 AND EHH.NRORG = EH.NRORG)
                 /*Natureza da Rubrica*/
                 JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
                WHERE IT.NRORG = ITC.NRORG
                  AND IT.NRVINCULOM = ITC.NRVINCULOM
                  AND IT.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                  AND IT.VREVENTOFOLHA > 0
                  AND ((IT.IDEVENDEMONCALC = 'N' AND EH.IDEVENTODEMONST = 'N') OR (EH.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/)
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRCHAVE" => $nrvinculom,
            "P_DTRESCISAOVINC" => $dtrescisao,
            "P_NRESTRUTLEGAL" => $nrestrutlegal,
            "P_NRESTRUTGEREN" => $nrestrutgeren,
            "P_CDCATEGTRAB" => $cdcategtrab,
            "P_INIVALIDADEAMB" => $inivalidadeamb,
            "P_MTVDESLIG" => $mtvDeslig,
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_NRPESSOA" => $nrpessoa,
            "P_NRINSC" => $nrinsc,
            "P_DTMESCOMPETENC" => $dtmescompetenc,
            "P_NRAGENTENOCIVO" => $nragentenocivo,
            "P_NRTIPOVINCULOM" => $nrtipovinculom,
        );
        
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS2299ideEstabLot($params) {
        $dados = $this->getDadosIdeEstabLot(
            $params['NRORG'], $params['NRVINCULOM'], $params['NRCALCULOFOLHA'], $params['NRESTRUTLEGAL'], $params['NRESTRUTGEREN'], $params['CDCATEGTRAB'], $params['DTMESCOMPETENC'], $params['NRAGENTENOCIVO']
        );
        return $dados;
    }
    
    public function getDadosIdeEstabLot($nrorg, $nrvinculom, $nrcalculofolha, $nrestrutlegal, $nrestrutgeren, $cdcategtrab, $dtmescompetenc, $nragentenocivo) {
        $sql = <<<SQL
/*getDadosS2299ideEstabLot*/
SELECT DISTINCT
       CASE
            WHEN (EH.CDCEIESTRUT IS NOT NULL AND EH.CDCAEPFESTRUT IS NULL) THEN '4'
            WHEN (EH.CDCEIESTRUT IS NULL AND EH.CDCAEPFESTRUT IS NOT NULL) THEN '3' 
            WHEN (EH.CDCEIESTRUT IS NOT NULL AND EH.CDCAEPFESTRUT IS NOT NULL) THEN '3'
            ELSE DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2')
       END tpInsc,
	   REPLACE(REPLACE(REPLACE(NVL(NVL(EH.CDCAEPFESTRUT,EH.CDCEIESTRUT),PN.NRINSCRICAOPARC),'.',''),'-',''),'/','') nrInsc,
       DECODE(:P_CDCATEGTRAB, '901', EM.NRESTRUTURAM, NVL(EMSUP.NRESTRUTURAM, EM.NRESTRUTURAM)) AS codLotacao,
       DECODE(AN.CDESOCIALNOCIVO,NULL,1,AN.CDESOCIALNOCIVO) AS grauExp,
       DECODE(NVL(CTSUP.CDESOCIAL,CT.CDESOCIAL),'03','3','') AS indSimples,
       EM.NRORG, :P_NRVINCULOM NRVINCULOM, :P_NRCALCULOFOLHA NRCALCULOFOLHA, :P_DTMESCOMPETENC DTMESCOMPETENC
  FROM ESTRUTURAM EM
  LEFT JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.NRORG = EM.NRORG
                    AND EH.DTMESCOMPETENC = (SELECT MAX(EHH.DTMESCOMPETENC) FROM ESTRUTURAH EHH
                                              WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND EHH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND EHH.NRORG = EH.NRORG)
  JOIN PARCNEGOCIO PN ON PN.NRORG = EM.NRORG
                     AND PN.NRPARCNEGOCIO = EM.NRPARCNEGOCIO
  LEFT JOIN CLASSTRIBUT CT ON CT.NRCLASSTRIBUT = EH.NRCLASSTRIBUT
  /*Tomador superior da estrutura gerencial*/
  LEFT JOIN TIPOHIERARQORG TH ON (TH.NRORG = EM.NRORG OR TH.NRORG = 0)
                             AND TH.NRTIPOESTRUTREL = :P_NRTIPOESTRUTGEREN
                             AND TH.NRTIPOESTRUTSUP = NVL(:P_NRTIPOESTRUTOMADOR, 7)
  LEFT JOIN HIERARQUIAORG HO ON HO.NRORG = EM.NRORG
                            AND HO.NRTIPOHIERARQORG = TH.NRTIPOHIERARQORG
                            AND HO.NRESTRUTURAMREL = :P_NRESTRUTGEREN
                            AND (HO.DTFIMVIGENCIA IS NULL OR HO.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
                            AND HO.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA)
                                                      FROM HIERARQUIAORG HI
                                                     WHERE HI.NRORG = HO.NRORG
                                                       AND HI.NRESTRUTURAMREL = HO.NRESTRUTURAMREL
                                                       AND NRTIPOHIERARQORG = HO.NRTIPOHIERARQORG
                                                       AND HI.DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC)
                                                       AND (HI.DTFIMVIGENCIA IS NULL OR HI.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
                                                       AND EM.DTINIVIGENCIA <= :P_DTMESCOMPETENC)
  LEFT JOIN ESTRUTURAM EMSUP ON EMSUP.NRESTRUTURAM = HO.NRESTRUTURAMSUP
                            AND EMSUP.NRORG = HO.NRORG
  LEFT JOIN ESTRUTURAH EHSUP ON EHSUP.NRESTRUTURAM = EMSUP.NRESTRUTURAM
                            AND EHSUP.NRORG = EMSUP.NRORG
                            AND EHSUP.DTMESCOMPETENC = (SELECT MAX(EHHSUP.DTMESCOMPETENC) FROM ESTRUTURAH EHHSUP
                                                         WHERE EHHSUP.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                           AND EHHSUP.NRESTRUTURAM = EH.NRESTRUTURAM
                                                           AND EHHSUP.NRORG = EH.NRORG)
  LEFT JOIN PARCNEGOCIO PNSUP ON PNSUP.NRPARCNEGOCIO = EMSUP.NRPARCNEGOCIO
                             AND PNSUP.NRORG = EMSUP.NRORG
  LEFT JOIN CLASSTRIBUT CTSUP ON CTSUP.NRCLASSTRIBUT = EHSUP.NRCLASSTRIBUT
  /*Grau de Exposição de Agente Nocivo*/
  LEFT JOIN GPE_AGENTENOCIVO AN ON AN.NRAGENTENOCIVO = :P_NRAGENTENOCIVO
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRESTRUTURAM = :P_NRESTRUTLEGAL
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $dtmescompetenc,
            "P_NRTIPOESTRUTGEREN" => $this->hcmParameters->getTipoEstruturaGerencialOrg(),
            "P_NRTIPOESTRUTOMADOR" => $this->hcmParameters->getTipoEstruturaTomadorOrg(),
            "P_NRVINCULOM" => $nrvinculom,
            "P_NRCALCULOFOLHA" => $nrcalculofolha,
            "P_NRESTRUTLEGAL" => $nrestrutlegal,
            "P_NRESTRUTGEREN" => $nrestrutgeren,
            "P_CDCATEGTRAB" => $cdcategtrab,
            "P_NRAGENTENOCIVO" => $nragentenocivo,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS2299detVerbas($params) {
        $dados = $this->getDadosDetVerbas(
            $params['NRORG'], $params['NRVINCULOM'], $params['NRCALCULOFOLHA'], $params['DTMESCOMPETENC']
        );
        return $dados;
    }
    
    public function getDadosDetVerbas($nrorg, $nrvinculom, $nrcalculofolha, $dtmescompetenc) {
        $sql = <<<SQL
/*getDadosS2299detVerbas*/
SELECT ITC.NREVENTOM AS codRubr,
       CASE WHEN TO_NUMBER(TO_CHAR(CF.DTOCORRENCIA,'MM')) BETWEEN 1 AND 11 AND CF.NRTIPOMOVIMENT = 4 THEN 22 ELSE CF.NRTIPOMOVIMENT END AS ideTabrubr,
       ROUND(DECODE(ITC.VRREFFOLHA, 0, '', ITC.VRREFFOLHA),2) AS qtdRubr,
       DECODE(EH.VRPERCENTUALEVENTO, 0, '', ROUND(EH.VRPERCENTUALEVENTO,2)) AS fatorRubr,
       ROUND(ITC.VREVENTOFOLHA,2) AS vrRubr,
       CASE WHEN CF.DTOCORRENCIA < TO_DATE('01/07/2021') THEN NULL ELSE 0 END AS indApurIR,
       ITC.NRORG, ITC.NRVINCULOM, ITC.NRCALCULOFOLHA, :P_DTMESCOMPETENC DTMESCOMPETENC
  FROM FPA_ITECALCFOLHA ITC
  JOIN FPA_CALCULOFOLHA CF ON ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                          AND CF.NRORG = ITC.NRORG
  JOIN FPA_EVENTOH EH ON EH.NREVENTOM = ITC.NREVENTOM
                     AND (EH.NRORG = :P_NRORG OR EH.NRORG = 0)
                     AND EH.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND EHH.NREVENTOM = EH.NREVENTOM
                                                  AND EHH.NRORG = EH.NRORG)
  /*Natureza da Rubrica*/
  JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
 WHERE ITC.NRORG = :P_NRORG
   AND ITC.NRVINCULOM = :P_NRCHAVE
   AND ITC.NRCALCULOFOLHA = :P_NRCALCULOFOLHA
   AND ITC.VREVENTOFOLHA > 0
   AND ((ITC.IDEVENDEMONCALC = 'N' AND EH.IDEVENTODEMONST = 'N') OR (EH.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/
 ORDER BY ITC.NREVENTOM
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $dtmescompetenc,
            "P_NRCHAVE" => $nrvinculom,
            "P_NRCALCULOFOLHA" => $nrcalculofolha
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS2299procJudTrab($params) {
        $dados = $this->getDadosProcJudTrab(
            $params['NRORG'], $params['NRESTRUTURAM'], $params['NRPARCNEGOCIO']
        );
        return $dados;
    }
    
     public function getDadosProcJudTrab($nrorg, $nrestrutura, $nrparcnegocio) {
        $sql = <<<SQL
/*getDadosS2299procJudTrab*/
SELECT AD.CDESOCIAL AS tpTrib,
       PA.NRPROCESSADMJUD AS nrProcJud,
       IPA.NRSUSPEXIGITPROC AS codSusp
  FROM GPE_PROCESSADMJUD PA
  JOIN GPE_ITEMPROCADMJUD IPA ON PA.NRORG = IPA.NRORG
                             AND PA.NRPROCESSADMJUD = IPA.NRPROCESSADMJUD
  LEFT JOIN GPE_ABDECISAO AD ON (AD.NRORG = IPA.NRORG OR AD.NRORG = 0)
                            AND AD.NRABDECISAO = IPA.NRABDECISAO
 WHERE PA.NRORG = :P_NRORG
   AND PA.NRESTRUTURAM = :P_NRESTRUTURAM
   AND PA.NRPARCNEGOCIO = :P_NRPARCNEGOCIO
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRESTRUTURAM" => $nrestrutura,
            "P_NRPARCNEGOCIO" => $nrparcnegocio,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS2299remunOutrEmpr($params) {
        if (!is_null($params['INDMV'])) {
            $dados = $this->getDadosremunOutrEmpr($params['NRORG'], $params['NRVINCULOM'], $params['NRPESSOA'], $params['DTMESCOMPETENC']);
        } else {
            $dados = array();
        }
        return $dados;
    }
    
    public function getDadosremunOutrEmpr($nrorg, $nrvinculom, $nrPessoa, $dtmescompetenc) {
        $sql = <<<SQL
/*getDadosS2299remunOutrEmpr*/
SELECT DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') AS tpInsc,
       PN.NRINSCRICAOPARC nrInsc,
       CE.CDESOCIAL AS codCateg,
       ITC.VREVENTOFOLHA AS vlrRemunOE,
       :P_DTMESCOMPETENC DTMESCOMPETENC
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.NRORG = VM.NRORG
                      AND VH.DTMESCOMPETENC = ( SELECT *
                                              FROM ( SELECT DTMESCOMPETENC
                                                     FROM GPE_VINCULOH
                                                     WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                       AND NRORG      = VH.NRORG
                                                       AND NRVINCULOM = VH.NRVINCULOM
                                                     ORDER BY DTMESCOMPETENC DESC )
                                               WHERE ROWNUM = 1 )
  /*Outro Empregador*/
  JOIN ESTRUTURAM EM ON EM.NRORG = VM.NRORG
                    AND EM.NRESTRUTURAM = VH.NRESTRUTLEGAL
  LEFT JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM    = EM.NRESTRUTURAM
                    AND EH.NRORG          = EM.NRORG
                    AND EH.DTMESCOMPETENC =
                      (SELECT MAX(EHH.DTMESCOMPETENC)
                      FROM ESTRUTURAH EHH
                      WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                      AND EHH.NRESTRUTURAM      = EH.NRESTRUTURAM
                      AND EHH.NRORG             = EH.NRORG)
  JOIN PARCNEGOCIO PN ON PN.NRORG             = EM.NRORG
                     AND PN.NRPARCNEGOCIO    = EM.NRPARCNEGOCIO
  /*Categoria Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  /*Remuneração Outra Empresa*/
  JOIN (SELECT ITC.NRORG, ITC.NRVINCULOM, SUM(ITC.VREVENTOFOLHA) VREVENTOFOLHA
          FROM FPA_ITECALCFOLHA ITC
          JOIN FPA_CALCULOFOLHA CF ON CF.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                  AND CF.NRORG = ITC.NRORG
                                  AND CF.NRTIPOMOVIMENT = 1
                                  AND CF.NRTPMODALIDCAL = 1
                                  AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
         WHERE ITC.NRORG = :P_NRORG
           AND ITC.NREVENTOM = 3050
           AND ITC.VREVENTOFOLHA > 0
         GROUP BY ITC.NRORG, ITC.NRVINCULOM) ITC ON ITC.NRORG = VM.NRORG
                                                AND ITC.NRVINCULOM = VM.NRVINCULOM
 WHERE VM.NRPESSOA = :P_NRPESSOA
   AND VM.NRORG = :P_NRORG
   AND VM.NRVINCULOM != :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $dtmescompetenc,
            "P_NRCHAVE" => $nrvinculom,
            "P_NRPESSOA" => $nrPessoa
        );
        return $this->connection->fetchAll($sql, $params);
    }

}