<?php

namespace HCM\PTO\Logic\AFD\Portaria671;

/**
 * Portaria 671
 * Gera valores de validacao sobre os itens de registros
 * 
 */

use HCM\Util\Util;
use HCM\PTO\Logic\AFD\ValidadorRegistro as ValidadorRegistroAFD;

class ValidadorRegistroCRC16 extends ValidadorRegistroAFD {
    /**
     * Portaria 671
     * Inclui a validacao CRC-16 (Cyclic Redundancy Check) para cada item
     * @param array $dadosRegistro
     * @return array
     */
    public function incluiValidacaoItens(array $dadosRegistro): array {
        foreach ($dadosRegistro as &$dadoRegistro) {
            $dadoRegistro .= substr(str_pad(Util::crc16($dadoRegistro), 4), 0, 4);
        }
        return $dadosRegistro;
    }
}