<?php

namespace HCM\SST\Services;

use Doctrine\ORM\EntityManager;
use Folha\Entities\GpeReuniao;
use Folha\Entities\GpeComite;
use Folha\Entities\GpeComiteparticipa;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\DateUtil;

class ComiteService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function deleteComite($dataset) {
        $nrorg = $dataset["NRORG"];
        $nrcomite = $dataset["NRCOMITE"];
        $participantes = GpeComiteparticipa::findOneByNrcomiteAndNrorg($nrcomite, $nrorg);
        $reuniao = GpeReuniao::findByNrcomiteAndNrorg($nrcomite, $nrorg);
        if (isset($participantes)) {
            throw new \Exception(Messages::HCM05000_SST_COMITE_EXISTS_PARTICIPANTES_ERROR, 10);
        }
        else if (isset($reuniao[0])) {
            throw new \Exception(Messages::HCM05000_SST_COMITE_EXISTS_REUNIAO_ERROR, 10);
        }
        else {
            $this->entityManager->beginTransaction();
            $comite = GpeComite::findOneByNrcomiteAndNrorg($nrcomite, $nrorg);
            $this->entityManager->remove($comite);
            $this->entityManager->flush();
            $this->entityManager->commit();
        }
    }
    
    public function cadastroAutomatico($nrcomite,$participantes_list,$ocupacao_list,$dtinicial,$dtfinal,$nrorg,$nrorgpadrao,$dtmescompetenc)
    {
        try{
            
            foreach($participantes_list as $key => $participante){
                $participantes = GpeComiteparticipa::findOneByNrcomiteAndNrorgAndNrparcnegocio($nrcomite, $nrorg, $participante);
                if(isset($participantes)){
                    continue;
                }
                $codigo = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'GPE_COMITEPARTICIPA', 1, 12, true);
                $obj = new \Folha\Entities\GpeComiteparticipa();
                $obj->setNrorg($this->hcmParameters->getNrorgTrabalho());
                $obj->setDtinclusao(DateUtil::getDataAtual());
                $obj->setCdoperinclusao($this->hcmParameters->getCdoperador());
                $obj->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
                $obj->setDtultatu(DateUtil::getDataAtual());
                $obj->setCdoperultatu($this->hcmParameters->getCdoperador());
                $obj->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
                $obj->setIdativo('S');
                $obj->setNrcomite($nrcomite);
                $obj->setNrcomiteparticipa($codigo);
                $obj->setNrparcnegocio($participante);
                $obj->setNrocupacaom($ocupacao_list[$key]);
                $obj->setDtiniparticipa($dtinicial);
                $obj->setDtfimparticipa($dtfinal);
                $obj->setDsobservacao(null);
                $this->entityManager->persist($obj);
                $this->entityManager->flush();
            }
        }catch(\Exception $e){
            throw $e;
        }
    }
}