-- ============================================================
-- Table: ESO_AQUIPRODRURAL
-- ============================================================
CREATE TABLE ESO_AQUIPRODRURAL
(
    NRORG                 NUMBER            NOT NULL,
    NRAQUIPRODRURAL        NUMBER            NOT NULL,
    NRESTRUTEMPREG        NUMBER            NOT NULL,
    NRESTRUTESTAB        NUMBER            NOT NULL,
    NRINDAQUIS            NUMBER            NOT NULL,
    CDINSCPROD            VARCHAR2(10)    NOT NULL,
    NRINSCPROD            VARCHAR2(20)    NOT NULL,
    VRBRUTOAQUIS        FLOAT            NOT NULL,
    VRCPDESCPR            FLOAT            DEFAULT 0 NOT NULL,
    VRRATDESCPR            FLOAT            DEFAULT 0 NOT NULL,
    VRSENARDESC            FLOAT            DEFAULT 0 NOT NULL,
    IDINDOPCCP            NUMBER            NOT NULL,
    IDATIVO                VARCHAR2(1)        DEFAULT 'S' NOT NULL
        CONSTRAINT CKC_IDATIVO_AQUIPRORUR CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU            DATE            NULL,
    NRORGINCLUSAO        NUMBER(22)        DEFAULT 1 NULL ,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL ,
    NRORGULTATU            NUMBER(22)        DEFAULT 1 NULL ,
    CDOPERULTATU        VARCHAR2(12)    DEFAULT '1' NULL ,
    CONSTRAINT PK_ESO_NRAQUIPRODRURAL PRIMARY KEY (NRORG, NRAQUIPRODRURAL),
    CONSTRAINT FK_AQUPRORUR_ESTREMPR FOREIGN KEY (NRORG, NRESTRUTEMPREG) REFERENCES ESTRUTURAM (NRORG, NRESTRUTURAM),
    CONSTRAINT FK_AQUPRORUR_ESTRESTA FOREIGN KEY (NRORG, NRESTRUTESTAB) REFERENCES ESTRUTURAM (NRORG, NRESTRUTURAM)
)
/