IF EXISTS (SELECT * FROM sysobjects O, sysusers U
           WHERE
            o.name = 'VALIDA_ENDEFILI_FISC'  and
            type = 'TR'             and
            u.uid = o.uid           and
            u.name = USER)

   DROP TRIGGER VALIDA_ENDEFILI_FISC;
GO

CREATE TRIGGER VALIDA_ENDEFILI_FISC
ON ENDEFILI
FOR INSERT, UPDATE
AS
DECLARE @V_IDUTENDMODFISC  VARCHAR(1);
DECLARE @V_DSENDEFILISEP      VARCHAR(50);
DECLARE @V_CDLOGRADOURO    VARCHAR(4);
DECLARE @V_NMBAIRFILI      VARCHAR(30);
DECLARE @V_NRCEPFILI       VARCHAR(15);
DECLARE @V_IDTPENDEFILI    VARCHAR(1);
BEGIN
   SET @V_IDUTENDMODFISC = NULL;

   SELECT @V_IDUTENDMODFISC = IDUTENDMODFISC
     FROM PARAMGERAL;

   DECLARE C_CURSOR CURSOR FOR
      SELECT INSERTED.DSENDEFILISEP,
             INSERTED.CDLOGRADOURO,
             INSERTED.NMBAIRFILI,
             INSERTED.NRCEPFILI,
             INSERTED.IDTPENDEFILI
        FROM INSERTED,
             DELETED
       WHERE INSERTED.CDFILIAL   = DELETED.CDFILIAL
         AND INSERTED.IDTPENDEFILI = DELETED.IDTPENDEFILI
   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_DSENDEFILISEP,
                                 @V_CDLOGRADOURO,
                                 @V_NMBAIRFILI,
                                 @V_NRCEPFILI,
                                 @V_IDTPENDEFILI;
   IF @V_IDUTENDMODFISC = 'S' BEGIN
      IF @V_IDTPENDEFILI = 'P' BEGIN
         IF @V_DSENDEFILISEP IS NULL BEGIN
            RAISERROR('Campo Endereo deve ser informado.', 16,1);
         END;
         IF @V_CDLOGRADOURO IS NULL BEGIN
            RAISERROR('Campo Lougradouro deve ser informado.', 16,1);
         END;
         IF @V_NMBAIRFILI IS NULL BEGIN
            RAISERROR('Campo Bairro deve ser informado.', 16,1);
         END;
         IF @V_NRCEPFILI IS NULL BEGIN
            RAISERROR('Campo CEP deve ser informado.', 16,1);
         END;
      END;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'VALIDA_ENDEFILI_FISC','5.50.xxx';
GO