#!/bin/bash

# Script que altera o parametro "aspUrl" de arquivos da LIB para o novo link
# Deve ser executado dentro da pasta em que se encontra

# Execute com '--production' para utilizar as configuracaoes de producao

# Interpretando argumentos
case "$1" in
    --production) is_prod=1 ;;
    *) is_prod=0 ;;
esac

# Definindo caminhos
case "$is_prod" in
    1) files_to_change=(
     ../../backend/vendor/teknisa/libraries/config/parameters.xml
     ../../backend_login/vendor/teknisa/libraries/config/parameters.xml
     ../../backend_acl/vendor/teknisa/libraries/config/parameters.xml
    ) ;;
    0) files_to_change=(
     ../../backend/vendor/teknisa/libraries/config/parameters.xml
     ../../modules/login/backend/vendor/teknisa/libraries/config/parameters.xml
     ../../modules/acl/backend/vendor/teknisa/libraries/config/parameters.xml
    ) ;;
    *) files_to_change=()
esac

original_asp_url='https:\/\/internal-asp.teknisa.com'
new_asp_url='https:\/\/security.teknisa.com'

echo "Alterando URL de parâmetros da LIB de $original_asp_url para $new_asp_url"

# Alterando os arquivos
for i in "${files_to_change[@]}"
do
    sed -i "s/$original_asp_url/$new_asp_url/g" $i \
        && echo "Arquivo $i alterado." \
        || echo "Arquivo $i NÂO alterado."
done

exit 0
